#ifndef lint
static const char yysccsid[] = "@(#)yaccpar	1.9 (Berkeley) 02/21/93";
#endif
#define YYBYACC 1
#define YYMAJOR 1
#define YYMINOR 9
#define yyclearin (yychar=(-1))
#define yyerrok (yyerrflag=0)
#define YYRECOVERING (yyerrflag!=0)
extern int yyparse(void);
#define YYPREFIX "yy"
#line 2 "config_grammar.y"
/*******************************************************************
 * Grammar for configuration file
 * 
 * Licensed under a dual GPL/BSD license.  (See LICENSE file for more info.)
 *
 * File: config_grammar.y
 *
 * Authors: bdpayne@cs.umd.edu, npetroni@cs.umd.edu, Chris.Hessing@utah.edu
 *
 * $Id: config_grammar.y,v 1.13 2006/10/05 22:23:49 chessing Exp $
 * $Date: 2006/10/05 22:23:49 $
 * $Log: config_grammar.y,v $
 * Revision 1.13  2006/10/05 22:23:49  chessing
 * Added new association option to the config file, and attempt to associate using methods other than open system.
 *
 * Revision 1.12  2006/06/01 22:49:49  galimorerpg
 * Converted all instances of u_char to uint8_t
 * Fixed a bad #include in the generic frame handler.
 *
 * Revision 1.11  2006/05/31 05:10:51  chessing
 * Beginnings of EAP-TTLS-EAP-MD5, and added internet draft for EAP-TTLS to doc/standards.
 *
 * Revision 1.10  2006/05/26 22:04:58  chessing
 * Fixed some memory access errors, and cleaned up some wext stuff that was causing issues with the madwifi driver in wext mode.
 *
 * Revision 1.9  2006/05/17 22:18:10  chessing
 * A couple of small changes to Xsupplicant, and some major changes to the GUI configuration/monitor tool.
 *
 * Revision 1.8  2006/05/13 05:56:44  chessing
 * Removed last pieces of code that relied on SIGALRM.  Active scan timeout is now configurable so that people that wish to hammer on their cards now have the option to do that. ;)
 *
 * Revision 1.7  2006/04/17 03:56:23  chessing
 * Added some support to enable/disable TNC support both via the configuration file, and via IPC.
 *
 * Revision 1.6  2006/03/08 00:16:04  chessing
 * Fixed EAP hints code to work correctly when the request ID packet is padded out with null bytes.  (Observed in Aruba APs.)  Some changes/fixes for the EAP-AKA module.
 *
 * Revision 1.5  2006/02/23 22:26:50  chessing
 * Fix for bug id #1415020.  'Building Xsupplicant 1.2.3 Fails on FC4'.
 *
 * Revision 1.4  2006/01/03 04:02:35  chessing
 * Added the ability to store the PEAP password in a hashed format.  (Basically, an MS-CHAPv1 hash.)  Also added an 'ntpwdhash' program to the tools directory that will convert a cleartext password in to a hash that can be copied to the configuration file.
 *
 * Revision 1.3  2005/11/10 04:56:54  chessing
 * Added patch from Ben Gardner to add support for setting a specific WEP key prior to attempting to associte.  (With a few slight modifications by me to make it fit in the current CVS code, and get it supported in config-parse.)  Added patch from Pekka Savola to fix some header ordering issues, and a potential buffer overflow.
 *
 * Revision 1.2  2005/10/26 18:56:12  chessing
 * Some build fixes and small updates.
 *
 * Revision 1.1  2005/10/17 00:15:55  chessing
 * Moved the config parsing routines out to a new library called libxsupconfig.a, so that it will be easier to create third-party tools that can easily parse a config.
 *
 * Revision 1.65  2005/10/14 02:26:17  shaftoe
 * - cleanup gcc 4 warnings
 * - (re)add support for a pid in the form of /var/run/xsupplicant.<iface>.pid
 *
 * -- Eric Evans <eevans@sym-link.com>
 *
 * Revision 1.64  2005/09/08 16:27:01  chessing
 * Some small updates to the new state machine code.  First attempt at an auto association mode.  (It mostly works. ;)
 *
 * Revision 1.63  2005/08/25 02:20:20  chessing
 * Some cleanup in xsup_debug.c, added the ability to wait for an interface to come up if it is down when Xsupplicant is started.  Roughed in the ability to choose between having Xsupplicant auto associate you, or allow you to set the ssid manually.  The stale key timer can now be set in the config file.  The association timeout can be set in the config file, and will also be used once the functionality is in place to attempt to guess the key settings needed for association, as well as the functionality to auto associate.
 *
 * Revision 1.62  2005/08/20 19:06:53  chessing
 * Patch from Carsten Grohmann to fix a few things in xsup_get_state.c.  Also added the ability to define an empty network clause, that will set the card in to encryption disabled mode.  From there, anything short of changing the SSID will be ignored by Xsupplicant.
 *
 * Revision 1.61  2005/08/18 03:19:04  chessing
 * Added the ability to define an SSID with static WEP keys.  When we switch to a network that has this type of configuration we will set the keys, and stop the various association timers.
 *
 * Revision 1.60  2005/08/12 03:34:06  chessing
 * Fix to the TLS implementation, should help avoid some of the weird 'block cipher pad' errors.  Also includes a partial implementation of the ability to use static WEP keys based on the SSID in use.
 *
 * Revision 1.59  2005/08/09 01:39:13  chessing
 * Cleaned out old commit notes from the released version.  Added a few small features including the ability to disable the friendly warnings that are spit out.  (Such as the warning that is displayed when keys aren't rotated after 10 minutes.)  We should also be able to start when the interface is down.  Last, but not least, we can handle empty network configs.  (This may be useful for situations where there isn't a good reason to have a default network defined.)
 *
 *******************************************************************/  
  
#include <stdlib.h>
#include <stdio.h>
#include <string.h>
#include <stdarg.h>
  
#include <profile.h>
#include "xsupconfig.h"
#include <xsup_err.h>
#include "xsup_debug.h"
#include "wpa.h"

#ifdef EAP_SIM_ENABLE
#include "winscard.h"
#endif

#ifdef USE_EFENCE
#include <efence.h>
#endif

#define CLEAN_EXIT cleanup_parse(); return XECONFIGPARSEFAIL

int yylex(void);  
int yyerror(char *err);

extern struct config_data *config_info;
extern int config_linenum;

extern int config_parse_debug;

struct config_data *tmp_config = NULL;

struct config_eap_tls *tmp_tls = NULL;
struct config_eap_md5 *tmp_md5 = NULL;
struct config_eap_ttls *tmp_ttls = NULL;
struct config_eap_leap *tmp_leap = NULL;
struct config_eap_mschapv2 *tmp_mschapv2 = NULL;
struct config_eap_peap *tmp_peap = NULL; 
struct config_eap_sim *tmp_sim = NULL;
struct config_eap_aka *tmp_aka = NULL;
struct config_wpa_psk *tmp_wpa_psk = NULL;
struct config_static_wep *tmp_static_wep = NULL;
struct config_static_wep *tmp_initial_wep = NULL;

struct config_pap *tmp_p2pap =NULL;
struct config_chap *tmp_p2chap = NULL;
struct config_mschap *tmp_p2mschap = NULL;
struct config_mschapv2 *tmp_p2mschapv2 = NULL;

struct config_network *tmp_network = NULL;



void set_current_tls() {
  if (tmp_tls == NULL) 
    initialize_config_eap_tls(&tmp_tls);
} 
void set_current_static_wep() {
  if (tmp_static_wep == NULL)
    initialize_config_static_wep(&tmp_static_wep);
}
void set_current_initial_wep() {
  if (tmp_initial_wep == NULL)
    initialize_config_static_wep(&tmp_initial_wep);
}
void set_current_md5() {
  if (tmp_md5 == NULL) 
    initialize_config_eap_md5(&tmp_md5);
} 
void set_current_ttls() {
  if (tmp_ttls == NULL) 
    initialize_config_eap_ttls(&tmp_ttls);
} 
void set_current_leap() {
  if (tmp_leap == NULL) 
    initialize_config_eap_leap(&tmp_leap);
} 
void set_current_mschapv2() {
  if (tmp_mschapv2 == NULL) 
    initialize_config_eap_mschapv2(&tmp_mschapv2);
} 
void set_current_peap() {
  if (tmp_peap == NULL) 
    initialize_config_eap_peap(&tmp_peap);
} 
void set_current_sim() {
  if (tmp_sim == NULL) 
    initialize_config_eap_sim(&tmp_sim);
} 

void set_current_aka() {
  if (tmp_aka == NULL)
    initialize_config_eap_aka(&tmp_aka);
}

void set_current_wpa_psk() {
  if (tmp_wpa_psk == NULL)
    initialize_config_wpa_psk(&tmp_wpa_psk);
}

void set_current_p2pap() {
  if (tmp_p2pap == NULL)
    initialize_config_pap(&tmp_p2pap);
}
void set_current_p2chap() {
  if (tmp_p2chap == NULL)
    initialize_config_chap(&tmp_p2chap);
}
void set_current_p2mschap() {
  if (tmp_p2mschap == NULL)
    initialize_config_mschap(&tmp_p2mschap);
}
void set_current_p2mschapv2() {
  if (tmp_p2mschapv2 == NULL)
    initialize_config_mschapv2(&tmp_p2mschapv2);
}

void set_current_config() {
  if (tmp_config == NULL) 
      initialize_config_data(&tmp_config);
} 

void set_current_globals() {
  set_current_config();
  if (!tmp_config->globals)
    initialize_config_globals(&(tmp_config->globals));
}   

void set_current_network() {
  if (tmp_network == NULL) 
    initialize_config_network(&tmp_network);
} 


void cleanup_parse()
{
  if (tmp_config)
    delete_config_data(&tmp_config);
  if (tmp_static_wep)
    delete_config_static_wep(&tmp_static_wep);
  if (tmp_initial_wep)
    delete_config_static_wep(&tmp_initial_wep);
  if (tmp_tls)
    delete_config_eap_tls(&tmp_tls);
  if (tmp_md5)
    delete_config_eap_md5(&tmp_md5);
  if (tmp_ttls)
    delete_config_eap_ttls(&tmp_ttls);
  if (tmp_leap)
    delete_config_eap_leap(&tmp_leap);
  if (tmp_mschapv2)
    delete_config_eap_mschapv2(&tmp_mschapv2);
  if (tmp_peap)
    delete_config_eap_peap(&tmp_peap);
  if (tmp_sim)
    delete_config_eap_sim(&tmp_sim);
  if (tmp_aka)
    delete_config_eap_aka(&tmp_aka);
  if (tmp_wpa_psk)
    delete_config_wpa_psk(&tmp_wpa_psk);
  if (tmp_p2pap)
    delete_config_pap(&tmp_p2pap);
  if (tmp_p2chap)
    delete_config_chap(&tmp_p2chap);
  if (tmp_p2mschap)
    delete_config_mschap(&tmp_p2mschap);
  if (tmp_p2mschapv2)
    delete_config_mschapv2(&tmp_p2mschapv2);
  if (tmp_network)
    delete_config_network(&tmp_network);
}



/* function to check if debug is on and if so print the message */
void parameter_debug(char *fmt, ...) {
  va_list ap;
  va_start(ap, fmt);
#ifndef PARSE_DEBUG
  return;
#endif
  vprintf(fmt, ap);
  va_end(ap);
}

#line 266 "config_grammar.y"
typedef union {
        char    *str;
        int     num;
} YYSTYPE;
#line 281 "config_grammar.c"
#define TK_NETWORK_LIST 257
#define TK_DEFAULT_NETNAME 258
#define TK_GENSTR 259
#define TK_DEFAULT_INT 260
#define TK_LOGFILE 261
#define TK_LOG_FACILITY 262
#define TK_AUTH_PERIOD 263
#define TK_HELD_PERIOD 264
#define TK_MAX_STARTS 265
#define TK_STALE_KEY_TIMEOUT 266
#define TK_ALLMULTI 267
#define TK_IPC_GROUP 268
#define TK_DESTINATION 269
#define TK_BSSID 270
#define TK_MULTICAST 271
#define TK_SOURCE 272
#define TK_AUTO 273
#define TK_MANUAL 274
#define TK_ASSOCIATION 275
#define TK_ASSOC_TIMEOUT 276
#define TK_ROAMING 277
#define TK_FIRMWARE 278
#define TK_XSUPPLICANT 279
#define TK_PASSIVE_SCANNING 280
#define TK_PASSIVE_TIMEOUT 281
#define TK_SCAN_TIMEOUT 282
#define TK_USE_EAP_HINTS 283
#define TK_ALL 284
#define TK_FRIENDLY_WARNINGS 285
#define TK_TYPE 286
#define TK_ALLOW_TYPES 287
#define TK_FORCE_EAPOL_VER 288
#define TK_WIRELESS 289
#define TK_WIRED 290
#define TK_CONTROL_WIRELESS 291
#define TK_ASSOCIATION_TYPE 292
#define TK_ASSOC_OPEN 293
#define TK_ASSOC_SHARED 294
#define TK_ASSOC_LEAP 295
#define TK_WPA_GROUP_CRYPT 296
#define TK_WPA_PAIRWISE_CRYPT 297
#define TK_WEP40 298
#define TK_TKIP 299
#define TK_WRAP 300
#define TK_CCMP 301
#define TK_WEP104 302
#define TK_ANY 303
#define TK_PRIORITY 304
#define TK_IDENTITY 305
#define TK_IDENTITY_VAL 306
#define TK_DEST_MAC 307
#define TK_MACADDRESS 308
#define TK_SSID 309
#define TK_SSID_VAL 310
#define TK_USE_TNC 311
#define TK_WPA_PSK 312
#define TK_WPA_PSK_KEY 313
#define TK_WPA_PSK_HEX_KEY 314
#define TK_EAP_TLS 315
#define TK_USER_CERT 316
#define TK_USER_KEY 317
#define TK_USER_KEY_PASS 318
#define TK_SESSION_RESUME 319
#define TK_CNCHECK 320
#define TK_CNEXACT 321
#define TK_ROOT_CERT 322
#define TK_ROOT_DIR 323
#define TK_CRL_DIR 324
#define TK_CHUNK_SIZE 325
#define TK_RANDOM_FILE 326
#define TK_EAP_MD5 327
#define TK_USERNAME 328
#define TK_USERNAME_VAL 329
#define TK_PASSWORD 330
#define TK_EAP_LEAP 331
#define TK_EAP_TTLS 332
#define TK_PHASE2_TYPE 333
#define TK_PAP 334
#define TK_CHAP 335
#define TK_MSCHAP 336
#define TK_MSCHAPV2 337
#define TK_EAP_MSCHAPV2 338
#define TK_MSCHAPV2_HASH_PWD 339
#define TK_IAS_QUIRK 340
#define TK_EAP_PEAP 341
#define TK_PEAPV1_PROPER_KEYING 342
#define TK_INNER_ID 343
#define TK_EAP_SIM 344
#define TK_EAP_AKA 345
#define TK_AUTO_REALM 346
#define TK_YES 347
#define TK_NO 348
#define TK_EAP_GTC 349
#define TK_EAP_OTP 350
#define TK_SMARTCARD 351
#define TK_ENGINE_ID 352
#define TK_OPENSC_SO_PATH 353
#define TK_KEYID 354
#define TK_STATIC_WEP 355
#define TK_INITIAL_WEP 356
#define TK_STATIC_KEY1 357
#define TK_STATIC_KEY2 358
#define TK_STATIC_KEY3 359
#define TK_STATIC_KEY4 360
#define TK_WEP_TX_KEY 361
#define TK_NUMBER 362
#define TK_UNQUOTED_STR 363
#define TK_PASS 364
#define TK_COMMAND 365
#define TK_QUOTED_STR 366
#define YYERRCODE 256
short yylhs[] = {                                        -1,
    0,    0,    0,    0,    1,    1,    2,    2,    3,    3,
    3,    3,    3,    3,    3,    3,    3,    3,    3,    3,
    3,    3,    3,    3,    3,    3,    3,    3,    3,    3,
    3,    3,    3,    3,    3,    3,    3,    3,    3,    3,
    3,    3,    3,    3,    3,    3,    3,    3,    3,    5,
    5,    5,    5,    4,    4,    4,    4,    4,    4,    6,
    6,    6,    6,    7,    7,    7,    7,    7,    7,    7,
    7,    7,    7,    7,   10,    9,    9,    9,   12,   12,
   12,   12,   12,   13,   13,   13,   13,   13,   14,   18,
   18,   18,   19,   19,   19,   15,   15,   15,   11,   11,
   16,   17,   17,    8,    8,    8,    8,    8,    8,    8,
    8,    8,    8,    8,   20,   20,   32,   32,   32,   32,
   32,   32,   32,   32,   32,   32,   24,   24,   33,   33,
   34,   34,   34,   34,   34,   25,   25,   35,   35,   36,
   36,   36,   36,   36,   21,   21,   37,   37,   39,   40,
   40,   41,   41,   41,   41,   41,   38,   38,   38,   38,
   38,   38,   38,   38,   38,   38,   38,   38,   38,   38,
   38,   38,   38,   38,   38,   38,   22,   22,   42,   42,
   43,   43,   43,   43,   43,   43,   23,   23,   44,   44,
   45,   45,   45,   45,   45,   45,   45,   45,   45,   45,
   45,   45,   45,   45,   45,   45,   45,   45,   45,   45,
   45,   45,   45,   45,   45,   45,   45,   45,   46,   46,
   46,   46,   46,   47,   52,   52,   53,   53,   53,   53,
   53,   53,   48,   54,   54,   55,   55,   55,   55,   55,
   55,   49,   56,   56,   57,   57,   57,   57,   57,   57,
   50,   58,   58,   59,   59,   59,   59,   59,   59,   51,
   26,   26,   60,   60,   61,   61,   61,   61,   61,   61,
   27,   27,   62,   62,   63,   63,   63,   63,   63,   63,
   63,   28,   28,   64,   64,   65,   65,   65,   65,   65,
   65,   65,   65,   65,   65,   65,   65,   65,   65,   65,
   65,   65,   65,   65,   65,   65,   65,   65,   65,   65,
   65,   65,   65,   65,   65,   65,   65,   65,   65,   65,
   66,   66,   68,   68,   69,   69,   69,   69,   69,   67,
   67,   67,   29,   29,   70,   70,   71,   71,   71,   71,
   71,   71,   71,   71,   71,   30,   30,   72,   72,   73,
   73,   73,   73,   73,   73,   73,   73,   73,   31,   31,
   74,   74,   75,   75,   75,
};
short yylen[] = {                                         2,
    2,    1,    1,    1,    2,    1,    2,    1,    3,    3,
    3,    3,    3,    3,    3,    3,    3,    3,    3,    3,
    3,    3,    3,    3,    3,    3,    3,    3,    3,    3,
    3,    3,    3,    3,    3,    3,    3,    3,    3,    3,
    3,    3,    3,    3,    3,    3,    3,    3,    3,    3,
    1,    3,    1,    4,    4,    4,    3,    3,    3,    2,
    2,    1,    1,    1,    1,    1,    1,    1,    1,    1,
    1,    1,    1,    1,    3,    3,    3,    3,    3,    3,
    3,    3,    3,    3,    3,    3,    3,    3,    3,    3,
    3,    3,    3,    3,    3,    3,    3,    3,    3,    3,
    3,    3,    3,    1,    1,    1,    1,    1,    1,    1,
    1,    1,    1,    1,    3,    1,    1,    1,    1,    1,
    1,    1,    1,    1,    1,    1,    4,    3,    2,    1,
    3,    3,    3,    3,    3,    4,    3,    2,    1,    3,
    3,    3,    3,    3,    4,    3,    2,    1,    4,    2,
    1,    3,    3,    3,    3,    3,    3,    3,    3,    3,
    3,    3,    3,    3,    3,    3,    3,    3,    3,    3,
    3,    3,    3,    3,    3,    1,    4,    3,    2,    1,
    3,    3,    3,    3,    3,    3,    4,    3,    2,    1,
    3,    3,    3,    3,    3,    3,    3,    3,    3,    3,
    3,    3,    3,    3,    3,    3,    3,    3,    3,    3,
    3,    3,    3,    3,    3,    3,    3,    1,    1,    1,
    1,    1,    1,    4,    2,    1,    3,    3,    3,    3,
    3,    3,    4,    2,    1,    3,    3,    3,    3,    3,
    3,    4,    2,    1,    3,    3,    3,    3,    3,    3,
    4,    2,    1,    3,    3,    3,    3,    3,    3,    1,
    4,    3,    2,    1,    3,    3,    3,    3,    3,    3,
    4,    3,    2,    1,    3,    3,    3,    3,    3,    3,
    3,    4,    3,    2,    1,    3,    3,    3,    3,    3,
    3,    3,    3,    3,    3,    3,    3,    3,    3,    3,
    3,    3,    3,    3,    3,    3,    3,    3,    3,    3,
    3,    3,    3,    3,    3,    3,    3,    3,    1,    1,
    3,    3,    3,    1,    1,    1,    1,    1,    1,    1,
    1,    1,    4,    3,    2,    1,    3,    3,    3,    3,
    3,    3,    3,    3,    3,    4,    3,    2,    1,    3,
    3,    3,    3,    3,    3,    3,    3,    3,    4,    3,
    2,    1,    3,    3,    3,
};
short yydefred[] = {                                      0,
    4,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    6,    8,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    5,    7,    9,   51,   53,    0,   11,
   12,   29,   27,   28,   49,   37,   38,   39,   30,   31,
   40,   41,   42,   43,   45,   46,   47,   44,   48,   32,
   33,   34,   35,   36,   16,   17,   18,   19,   20,   21,
   25,   26,   22,   23,   24,   13,   14,   15,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
   59,    0,   62,   63,   64,   65,   66,   67,   68,   69,
   70,   71,   72,   73,   74,  104,  105,  106,  107,  108,
  109,  110,  111,  112,  113,  114,   57,    0,   58,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,   55,   60,   61,   54,   56,   50,   52,
   76,   77,   78,  102,  117,  118,  120,  119,  121,  122,
  123,  124,  125,  126,    0,  116,   89,   93,   94,   95,
   90,   91,   92,   79,   80,   81,   82,   83,   84,   85,
   86,   87,   88,   75,   96,   98,   97,  101,   99,  100,
    0,    0,  360,    0,  362,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,  146,    0,  148,  176,    0,
    0,  178,    0,  180,    0,    0,  262,    0,  264,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,  188,  260,    0,  190,  218,
  219,  220,  221,  222,  223,    0,    0,    0,  272,    0,
  274,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,  283,  331,  330,
  332,    0,  285,  319,  320,    0,    0,    0,  334,    0,
  336,    0,    0,    0,  347,    0,  349,    0,    0,    0,
    0,    0,  128,    0,  130,    0,    0,    0,    0,    0,
  137,    0,  139,    0,    0,    0,  359,  361,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,  145,  147,
    0,    0,  177,  179,    0,    0,  261,  263,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,  187,  189,    0,    0,    0,  271,
  273,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,  282,  284,    0,
    0,    0,  333,  335,    0,    0,    0,  346,  348,    0,
    0,    0,    0,    0,  127,  129,    0,    0,    0,    0,
    0,  136,  138,  115,  363,  364,  365,  157,  158,  159,
  160,  163,  161,  162,  164,  165,  166,  167,  168,  169,
  170,  171,  172,  173,  174,  175,    0,    0,    0,    0,
    0,  181,  182,  183,  185,  184,  186,  265,  266,  267,
  269,  268,  270,  191,  192,  193,  194,  196,  195,  197,
  207,  208,  209,  210,  211,  212,  198,  199,  200,  201,
  202,  203,  204,  205,  206,  217,  213,  214,  215,  216,
    0,    0,    0,  226,    0,    0,    0,  235,    0,    0,
    0,  244,    0,    0,    0,  253,  275,  276,  277,  279,
  278,  280,  281,  321,  326,  325,  327,  329,  328,    0,
  324,  286,  287,  288,  289,  290,  291,  292,  294,  293,
  295,  302,  303,  304,  311,  312,  313,  296,  297,  298,
  299,  300,  301,  310,  314,  315,  316,  317,  318,  305,
  306,  307,  308,  309,  337,  338,  339,  341,  340,  342,
  343,  344,  345,  350,  351,  352,  354,  353,  355,  356,
  357,  358,  131,  132,  133,  134,  135,  140,  141,  142,
  143,  144,    0,    0,    0,  149,  150,    0,    0,  224,
  225,    0,    0,  233,  234,    0,    0,  242,  243,    0,
    0,  251,  252,    0,  152,  153,  154,  156,  155,  227,
  228,  229,  231,  230,  232,  236,  237,  238,  240,  239,
  241,  245,  246,  247,  249,  248,  250,  254,  255,  256,
  258,  257,  259,  323,
};
short yydgoto[] = {                                      25,
   26,   27,   28,   29,   59,  122,  123,  124,  125,  126,
  127,  128,  129,  130,  131,  132,  133,  134,  135,  195,
  136,  137,  138,  139,  140,  141,  142,  143,  144,  145,
  146,  196,  324,  325,  332,  333,  237,  238,  239,  450,
  451,  243,  244,  268,  269,  270,  271,  272,  273,  274,
  275,  493,  494,  497,  498,  501,  502,  505,  506,  248,
  249,  280,  281,  302,  303,  304,  305,  520,  521,  310,
  311,  316,  317,  224,  225,
};
short yysindex[] = {                                   -228,
    0,  -16,    3,    5,   12,   20,   46,   52,   57,  108,
  112,  123,  131,  136,  149,  170,  192,  231,  251,  270,
  278,  -48,   30,  226,    0,  630, -221,    0,    0, -272,
 -305, -235, -106,    7,   -8,   49,   63, -239, -226,   11,
 -253, -252, -204, -255, -192,   78,   97, -172, -165,    2,
   64,  130, -221,    0,    0,    0,    0,    0,  309,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,  331,  368,
  399,  419,  432,  440,  454,  459,  465,  472,  476,  438,
  439,  442,  443,  445,  446,  447,  448,  449,  450,  451,
    0,  191,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,  252,    0,  313,
  -92, -246, -184,  213,   18,  257,  150,  165,  214, -292,
  269, -169, -109, -123, -122, -121,  527,  -43,  416, -117,
 -116, -125, -120,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,  534,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
  519,  520,    0,  -98,    0,  524,  525,  526,  528,  530,
  531,  533,  537,  541,  480,    0,  -99,    0,    0,  545,
  550,    0,  -33,    0,  551,  552,    0,  -27,    0,  553,
  554,  555,  558,  560,  561,  565,  566,  568,  569,  570,
  571,  510,  511,  512,  513,    0,    0,  549,    0,    0,
    0,    0,    0,    0,    0,  576,  577,  578,    0,  -28,
    0,  580,  581,  582,  585,  586,  587,  588,  589,  592,
  594,  595,  598,  602,  603,  606,  611,    0,    0,    0,
    0,  457,    0,    0,    0,  612,  614,  615,    0,  -74,
    0,  616,  619,  621,    0,  -55,    0,  622,  623,  626,
  627,  629,    0, -115,    0,  631,  632,  633,  634,  635,
    0, -110,    0, -164,  -18,  225,    0,    0,   -4,   27,
 -278,   25,   31,   44,   70,  233,   92,  201,    0,    0,
 -304, -214,    0,    0, -298, -176,    0,    0,  110,  118,
  -36,   35,  328, -126,  128,  134,  145,  335,  146, -258,
   -5,   50,   71,  230,    0,    0, -283,  -22,  336,    0,
    0, -224, -264,  147,  151,   23,   37,  337,  -68,  153,
  158,  162,  340,  164,   65,   67,  168,    0,    0, -279,
   40,   76,    0,    0, -273,   80,   84,    0,    0,  332,
  338,  341,  342,  347,    0,    0,  344,  345,  348,  350,
  351,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,  656,  659,  661,  599,
  201,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
  662,  664,  -20,    0,  665,  666,  -10,    0,  667,  670,
   -9,    0,  684,  685,   -6,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,  703,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,  385,  179,  -58,    0,    0, -262,   90,    0,
    0, -257,  106,    0,    0, -234,  126,    0,    0, -233,
  141,    0,    0,  -12,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,
};
short yyrindex[] = {                                      0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,  749,  750,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,  751,    0,    0,    0,    0,    0,    1,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,  374,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
  628,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,  498,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,
};
short yygindex[] = {                                      0,
    0,  726,  729,   36,    0,  284,   14,   22,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0, -156,    0,    0,    0,    0, -163,    0, -162,    0,
    0,  423,    0,  437,    0,  431,    0,  529,    0,  314,
    0,    0,  521,    0,  499,    0,    0,    0,    0,    0,
    0,    0,  275,    0,  272,    0,  271,    0,  265,    0,
  523,    0,  506,    0,  485,    0,    0,    0,  184,    0,
  479,    0,  474,    0,  567,
};
#define YYTABLESIZE 996
short yytable[] = {                                     323,
   10,  236,  242,  247,  331,  300,  301,  309,  315,  415,
  267,   56,  299,  215,  422,  223,   75,   76,   77,   78,
   80,   81,   85,   86,  452,  349,  337,    1,    2,    3,
  458,    4,    5,    6,    7,    8,    9,   10,   11,   12,
   13,  522,  181,  182,   30,  507,   14,   15,   16,  555,
  403,   17,   18,   19,   20,  564,   21,   60,  453,  514,
   61,  454,   55,   31,  459,   32,  610,  460,  486,  408,
  216,  616,   33,  217,   50,  487,  488,  489,  490,  508,
   34,  279,  509,  556,  432,  433,  557,  434,   55,  565,
   57,  353,  566,   58,  622,  628,  380,  357,  523,  184,
  611,  524,  515,  612,  590,  617,   35,   87,  618,   79,
   82,  267,   36,  516,  594,  598,  183,   37,  602,  517,
   71,   72,   69,   70,  518,  519,  121,   62,  623,  629,
  185,  624,  630,   22,   23,  175,   73,   24,  300,  301,
   22,   23,  186,  176,   24,  299,  187,  188,  455,  456,
  185,  457,   51,  189,   88,   89,  190,   83,   84,  191,
  192,  175,  186,  175,  193,  194,  187,  188,   38,  176,
   90,  176,   39,  189,   93,   94,  190,  219,  220,  191,
  192,   96,   97,   40,  193,  194,  461,  462,  147,  463,
   95,   41,  226,  227,  228,  229,   42,   98,  230,  231,
  232,  233,  234,  221,  222,  240,  245,  241,  246,   43,
  306,  312,  307,  313,  221,  222,  226,  227,  228,  229,
  475,  476,  230,  231,  232,  233,  234,  235,  308,  314,
   44,  318,  319,  320,  321,  322,  326,  327,  328,  329,
  330,  318,  319,  320,  321,  322,  326,  327,  328,  329,
  330,  235,   45,  306,  149,  307,   63,   10,   10,   64,
   10,   10,   10,   10,   10,   10,   10,   10,   10,   10,
  179,  308,  312,  180,  313,   10,   10,   10,  536,  537,
   10,   10,   10,   10,  276,   10,  277,   99,  100,  101,
  314,   46,  102,  103,  240,  278,  241,  104,  105,  276,
  245,  277,  246,  608,  609,  106,  107,  491,  108,  492,
  278,   47,  109,  110,  515,  174,  111,  495,  499,  496,
  500,  503,  491,  504,  492,  516,  468,  469,  112,  470,
   48,  517,  113,  114,  148,  150,  518,  519,   49,  115,
  510,  511,  116,  512,  425,  117,  118,  426,   52,   99,
  100,  101,  151,   66,  102,  103,  119,  120,  428,  104,
  105,  429,   10,   10,  198,  199,   10,  106,  107,   65,
  108,  435,  436,   74,  109,  110,  177,  495,  111,  496,
  200,  471,  472,  532,  533,  529,  530,  437,  531,  430,
  112,  152,  431,  438,  113,  114,  439,  473,  499,  534,
  500,  115,  558,  559,  116,  560,  440,  117,  118,  441,
   67,  547,  548,  550,  551,   99,  100,  101,  119,  120,
  102,  103,  561,  562,   68,  104,  105,  549,  153,  552,
  570,  571,  442,  106,  107,  443,  108,  178,  563,   91,
  109,  110,  567,  568,  111,  569,  572,  204,  205,  206,
  207,  208,  613,  614,  445,  615,  112,  446,   92,  154,
  113,  114,  209,  210,  211,  212,  213,  115,  619,  620,
  116,  621,  464,  117,  118,  465,   99,  100,  101,  155,
  466,  102,  103,  467,  119,  120,  104,  105,  625,  626,
  477,  627,  156,  478,  106,  107,  479,  108,  103,  480,
  157,  109,  110,  631,  632,  111,  633,  481,  484,  525,
  482,  485,  526,  527,  158,  538,  528,  112,  539,  159,
  540,  113,  114,  541,  542,  160,  545,  543,  115,  546,
  553,  116,  161,  554,  117,  118,  162,   99,  100,  101,
  298,  606,  102,  103,  607,  119,  120,  104,  105,  201,
  202,  203,  447,  448,  449,  106,  107,  503,  108,  504,
  163,  164,  109,  110,  165,  166,  111,  167,  168,  169,
  170,  171,  172,  173,  197,  214,  218,  334,  112,  335,
  336,  398,  113,  114,  339,  340,  341,  427,  342,  115,
  343,  344,  116,  345,  444,  117,  118,  346,   99,  100,
  101,  347,  348,  102,  103,  351,  119,  120,  104,  105,
  352,  355,  356,  359,  360,  361,  106,  107,  362,  108,
  363,  364,  322,  109,  110,  365,  366,  111,  367,  368,
  369,  370,  371,  372,  373,  374,  377,  378,  379,  112,
  382,  383,  384,  113,  114,  385,  386,  387,  388,  389,
  115,  266,  390,  116,  391,  392,  117,  118,  393,  103,
  103,  103,  394,  395,  103,  103,  396,  119,  120,  103,
  103,  397,  400,  375,  401,  402,  405,  103,  103,  406,
  103,  407,  410,  411,  103,  103,  412,  413,  103,  414,
  474,  417,  418,  419,  420,  421,  483,  573,  513,  535,
  103,  544,  282,  574,  103,  103,  575,  576,  577,  578,
  579,  103,  582,  580,  103,  581,  583,  103,  103,  584,
  283,  585,  588,  586,  589,  592,  593,  596,  103,  103,
  597,  284,  285,  286,  287,  288,  289,  290,  291,  292,
  293,  294,  112,  282,  600,  601,  604,  605,    2,    3,
    1,   53,  151,  115,   54,  295,  424,  296,  297,  117,
  416,  283,  423,  354,  587,  350,  376,  591,  595,  603,
  358,  599,  284,  285,  286,  287,  288,  289,  290,  291,
  292,  293,  294,  112,  322,  381,  399,  634,  404,  409,
  338,    0,    0,    0,  115,    0,  295,    0,  296,  297,
  117,    0,  322,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,  322,  322,  322,  322,  322,  322,  322,
  322,  322,  322,  322,  322,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,  322,    0,  322,    0,  322,
  322,  322,  250,  251,  252,  253,  254,  255,  256,  257,
  258,  259,  260,  112,    0,    0,    0,    0,    0,  261,
  262,  263,  264,  265,  250,  251,  252,  253,  254,  255,
  256,  257,  258,  259,  260,  112,    0,    0,    0,    0,
    0,  261,  262,  263,  264,  265,    2,    3,    0,    4,
    5,    6,    7,    8,    9,   10,   11,   12,   13,    0,
    0,    0,    0,    0,   14,   15,   16,    0,    0,   17,
   18,   19,   20,    0,   21,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,   22,   23,    0,    0,   24,
};
short yycheck[] = {                                     125,
    0,  125,  125,  125,  125,  169,  169,  125,  125,  125,
  167,  284,  169,  306,  125,  125,  270,  271,  272,  273,
  273,  274,  278,  279,  329,  125,  125,  256,  257,  258,
  329,  260,  261,  262,  263,  264,  265,  266,  267,  268,
  269,  306,  289,  290,   61,  329,  275,  276,  277,  329,
  125,  280,  281,  282,  283,  329,  285,  363,  363,  284,
  366,  366,   27,   61,  363,   61,  329,  366,  327,  125,
  363,  329,   61,  366,  123,  334,  335,  336,  337,  363,
   61,  125,  366,  363,  363,  364,  366,  366,   53,  363,
  363,  125,  366,  366,  329,  329,  125,  125,  363,  284,
  363,  366,  327,  366,  125,  363,   61,  363,  366,  363,
  363,  268,   61,  338,  125,  125,  363,   61,  125,  344,
  347,  348,  362,  363,  349,  350,  125,  363,  363,  363,
  315,  366,  366,  362,  363,  122,  363,  366,  302,  302,
  362,  363,  327,  122,  366,  302,  331,  332,  363,  364,
  315,  366,  123,  338,  347,  348,  341,  362,  363,  344,
  345,  148,  327,  150,  349,  350,  331,  332,   61,  148,
  363,  150,   61,  338,  347,  348,  341,  347,  348,  344,
  345,  347,  348,   61,  349,  350,  363,  364,  125,  366,
  363,   61,  316,  317,  318,  319,   61,  363,  322,  323,
  324,  325,  326,  313,  314,  328,  328,  330,  330,   61,
  328,  328,  330,  330,  313,  314,  316,  317,  318,  319,
  347,  348,  322,  323,  324,  325,  326,  351,  346,  346,
   61,  357,  358,  359,  360,  361,  357,  358,  359,  360,
  361,  357,  358,  359,  360,  361,  357,  358,  359,  360,
  361,  351,   61,  328,  125,  330,  363,  257,  258,  366,
  260,  261,  262,  263,  264,  265,  266,  267,  268,  269,
  363,  346,  328,  366,  330,  275,  276,  277,  347,  348,
  280,  281,  282,  283,  328,  285,  330,  286,  287,  288,
  346,   61,  291,  292,  328,  339,  330,  296,  297,  328,
  328,  330,  330,  362,  363,  304,  305,  328,  307,  330,
  339,   61,  311,  312,  327,  125,  315,  328,  328,  330,
  330,  328,  328,  330,  330,  338,  363,  364,  327,  366,
   61,  344,  331,  332,   51,   52,  349,  350,   61,  338,
  363,  364,  341,  366,  363,  344,  345,  366,  123,  286,
  287,  288,   44,  362,  291,  292,  355,  356,  363,  296,
  297,  366,  362,  363,  347,  348,  366,  304,  305,  363,
  307,  347,  348,  363,  311,  312,  125,  328,  315,  330,
  363,  347,  348,  347,  348,  363,  364,  363,  366,  363,
  327,   61,  366,  363,  331,  332,  366,  363,  328,  363,
  330,  338,  363,  364,  341,  366,  363,  344,  345,  366,
  362,  347,  348,  347,  348,  286,  287,  288,  355,  356,
  291,  292,  347,  348,  362,  296,  297,  363,   61,  363,
  347,  348,  363,  304,  305,  366,  307,  125,  363,  362,
  311,  312,  363,  364,  315,  366,  363,  298,  299,  300,
  301,  302,  363,  364,  363,  366,  327,  366,  362,   61,
  331,  332,  298,  299,  300,  301,  302,  338,  363,  364,
  341,  366,  363,  344,  345,  366,  286,  287,  288,   61,
  363,  291,  292,  366,  355,  356,  296,  297,  363,  364,
  363,  366,   61,  366,  304,  305,  363,  307,  125,  366,
   61,  311,  312,  363,  364,  315,  366,  363,  363,  363,
  366,  366,  366,  363,   61,  363,  366,  327,  366,   61,
  363,  331,  332,  366,  363,   61,  363,  366,  338,  366,
  363,  341,   61,  366,  344,  345,   61,  286,  287,  288,
  125,  363,  291,  292,  366,  355,  356,  296,  297,  293,
  294,  295,  352,  353,  354,  304,  305,  328,  307,  330,
  123,  123,  311,  312,  123,  123,  315,  123,  123,  123,
  123,  123,  123,  123,  362,  362,  308,   44,  327,   61,
   61,  125,  331,  332,   61,   61,   61,  363,   61,  338,
   61,   61,  341,   61,  362,  344,  345,   61,  286,  287,
  288,   61,  123,  291,  292,   61,  355,  356,  296,  297,
   61,   61,   61,   61,   61,   61,  304,  305,   61,  307,
   61,   61,  125,  311,  312,   61,   61,  315,   61,   61,
   61,   61,  123,  123,  123,  123,   61,   61,   61,  327,
   61,   61,   61,  331,  332,   61,   61,   61,   61,   61,
  338,  125,   61,  341,   61,   61,  344,  345,   61,  286,
  287,  288,   61,   61,  291,  292,   61,  355,  356,  296,
  297,   61,   61,  125,   61,   61,   61,  304,  305,   61,
  307,   61,   61,   61,  311,  312,   61,   61,  315,   61,
  363,   61,   61,   61,   61,   61,  362,  366,  363,  363,
  327,  362,  287,  366,  331,  332,  366,  366,  362,  366,
  366,  338,  362,  366,  341,  366,   61,  344,  345,   61,
  305,   61,   61,  125,   61,   61,   61,   61,  355,  356,
   61,  316,  317,  318,  319,  320,  321,  322,  323,  324,
  325,  326,  327,  287,   61,   61,   44,  363,    0,    0,
    0,   26,  125,  338,   26,  340,  334,  342,  343,  344,
  324,  305,  332,  243,  451,  237,  268,  493,  497,  505,
  248,  501,  316,  317,  318,  319,  320,  321,  322,  323,
  324,  325,  326,  327,  287,  280,  302,  604,  310,  316,
  224,   -1,   -1,   -1,  338,   -1,  340,   -1,  342,  343,
  344,   -1,  305,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,  316,  317,  318,  319,  320,  321,  322,
  323,  324,  325,  326,  327,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,  338,   -1,  340,   -1,  342,
  343,  344,  316,  317,  318,  319,  320,  321,  322,  323,
  324,  325,  326,  327,   -1,   -1,   -1,   -1,   -1,  333,
  334,  335,  336,  337,  316,  317,  318,  319,  320,  321,
  322,  323,  324,  325,  326,  327,   -1,   -1,   -1,   -1,
   -1,  333,  334,  335,  336,  337,  257,  258,   -1,  260,
  261,  262,  263,  264,  265,  266,  267,  268,  269,   -1,
   -1,   -1,   -1,   -1,  275,  276,  277,   -1,   -1,  280,
  281,  282,  283,   -1,  285,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,  362,  363,   -1,   -1,  366,
};
#define YYFINAL 25
#ifndef YYDEBUG
#define YYDEBUG 0
#endif
#define YYMAXTOKEN 366
#if YYDEBUG
char *yyname[] = {
"end-of-file",0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
0,0,0,0,0,0,0,0,0,0,"','",0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,"'='",0,0,0,0,0,0,0,0,
0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
0,0,0,0,0,0,0,0,0,0,0,0,0,"'{'",0,"'}'",0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,"TK_NETWORK_LIST",
"TK_DEFAULT_NETNAME","TK_GENSTR","TK_DEFAULT_INT","TK_LOGFILE",
"TK_LOG_FACILITY","TK_AUTH_PERIOD","TK_HELD_PERIOD","TK_MAX_STARTS",
"TK_STALE_KEY_TIMEOUT","TK_ALLMULTI","TK_IPC_GROUP","TK_DESTINATION","TK_BSSID",
"TK_MULTICAST","TK_SOURCE","TK_AUTO","TK_MANUAL","TK_ASSOCIATION",
"TK_ASSOC_TIMEOUT","TK_ROAMING","TK_FIRMWARE","TK_XSUPPLICANT",
"TK_PASSIVE_SCANNING","TK_PASSIVE_TIMEOUT","TK_SCAN_TIMEOUT","TK_USE_EAP_HINTS",
"TK_ALL","TK_FRIENDLY_WARNINGS","TK_TYPE","TK_ALLOW_TYPES","TK_FORCE_EAPOL_VER",
"TK_WIRELESS","TK_WIRED","TK_CONTROL_WIRELESS","TK_ASSOCIATION_TYPE",
"TK_ASSOC_OPEN","TK_ASSOC_SHARED","TK_ASSOC_LEAP","TK_WPA_GROUP_CRYPT",
"TK_WPA_PAIRWISE_CRYPT","TK_WEP40","TK_TKIP","TK_WRAP","TK_CCMP","TK_WEP104",
"TK_ANY","TK_PRIORITY","TK_IDENTITY","TK_IDENTITY_VAL","TK_DEST_MAC",
"TK_MACADDRESS","TK_SSID","TK_SSID_VAL","TK_USE_TNC","TK_WPA_PSK",
"TK_WPA_PSK_KEY","TK_WPA_PSK_HEX_KEY","TK_EAP_TLS","TK_USER_CERT","TK_USER_KEY",
"TK_USER_KEY_PASS","TK_SESSION_RESUME","TK_CNCHECK","TK_CNEXACT","TK_ROOT_CERT",
"TK_ROOT_DIR","TK_CRL_DIR","TK_CHUNK_SIZE","TK_RANDOM_FILE","TK_EAP_MD5",
"TK_USERNAME","TK_USERNAME_VAL","TK_PASSWORD","TK_EAP_LEAP","TK_EAP_TTLS",
"TK_PHASE2_TYPE","TK_PAP","TK_CHAP","TK_MSCHAP","TK_MSCHAPV2","TK_EAP_MSCHAPV2",
"TK_MSCHAPV2_HASH_PWD","TK_IAS_QUIRK","TK_EAP_PEAP","TK_PEAPV1_PROPER_KEYING",
"TK_INNER_ID","TK_EAP_SIM","TK_EAP_AKA","TK_AUTO_REALM","TK_YES","TK_NO",
"TK_EAP_GTC","TK_EAP_OTP","TK_SMARTCARD","TK_ENGINE_ID","TK_OPENSC_SO_PATH",
"TK_KEYID","TK_STATIC_WEP","TK_INITIAL_WEP","TK_STATIC_KEY1","TK_STATIC_KEY2",
"TK_STATIC_KEY3","TK_STATIC_KEY4","TK_WEP_TX_KEY","TK_NUMBER","TK_UNQUOTED_STR",
"TK_PASS","TK_COMMAND","TK_QUOTED_STR",
};
char *yyrule[] = {
"$accept : configfile",
"configfile : global_section network_section",
"configfile : global_section",
"configfile : network_section",
"configfile : error",
"global_section : global_section global_statement",
"global_section : global_statement",
"network_section : network_section network_entry",
"network_section : network_entry",
"global_statement : TK_NETWORK_LIST '=' TK_ALL",
"global_statement : TK_NETWORK_LIST '=' network_list",
"global_statement : TK_DEFAULT_NETNAME '=' TK_UNQUOTED_STR",
"global_statement : TK_DEFAULT_NETNAME '=' TK_QUOTED_STR",
"global_statement : TK_FRIENDLY_WARNINGS '=' TK_YES",
"global_statement : TK_FRIENDLY_WARNINGS '=' TK_NO",
"global_statement : TK_FRIENDLY_WARNINGS '=' TK_UNQUOTED_STR",
"global_statement : TK_ROAMING '=' TK_FIRMWARE",
"global_statement : TK_ROAMING '=' TK_XSUPPLICANT",
"global_statement : TK_ROAMING '=' TK_UNQUOTED_STR",
"global_statement : TK_PASSIVE_SCANNING '=' TK_YES",
"global_statement : TK_PASSIVE_SCANNING '=' TK_NO",
"global_statement : TK_PASSIVE_SCANNING '=' TK_UNQUOTED_STR",
"global_statement : TK_USE_EAP_HINTS '=' TK_YES",
"global_statement : TK_USE_EAP_HINTS '=' TK_NO",
"global_statement : TK_USE_EAP_HINTS '=' TK_UNQUOTED_STR",
"global_statement : TK_PASSIVE_TIMEOUT '=' TK_NUMBER",
"global_statement : TK_SCAN_TIMEOUT '=' TK_NUMBER",
"global_statement : TK_LOGFILE '=' TK_UNQUOTED_STR",
"global_statement : TK_LOGFILE '=' TK_QUOTED_STR",
"global_statement : TK_DEFAULT_INT '=' TK_UNQUOTED_STR",
"global_statement : TK_STALE_KEY_TIMEOUT '=' TK_NUMBER",
"global_statement : TK_STALE_KEY_TIMEOUT '=' TK_UNQUOTED_STR",
"global_statement : TK_ASSOCIATION '=' TK_AUTO",
"global_statement : TK_ASSOCIATION '=' TK_MANUAL",
"global_statement : TK_ASSOCIATION '=' TK_UNQUOTED_STR",
"global_statement : TK_ASSOC_TIMEOUT '=' TK_NUMBER",
"global_statement : TK_ASSOC_TIMEOUT '=' TK_UNQUOTED_STR",
"global_statement : TK_AUTH_PERIOD '=' TK_NUMBER",
"global_statement : TK_HELD_PERIOD '=' TK_NUMBER",
"global_statement : TK_MAX_STARTS '=' TK_NUMBER",
"global_statement : TK_ALLMULTI '=' TK_YES",
"global_statement : TK_ALLMULTI '=' TK_NO",
"global_statement : TK_ALLMULTI '=' TK_UNQUOTED_STR",
"global_statement : TK_IPC_GROUP '=' TK_UNQUOTED_STR",
"global_statement : TK_DESTINATION '=' TK_AUTO",
"global_statement : TK_DESTINATION '=' TK_BSSID",
"global_statement : TK_DESTINATION '=' TK_MULTICAST",
"global_statement : TK_DESTINATION '=' TK_SOURCE",
"global_statement : TK_DESTINATION '=' TK_UNQUOTED_STR",
"global_statement : TK_LOG_FACILITY '=' TK_UNQUOTED_STR",
"network_list : network_list ',' TK_UNQUOTED_STR",
"network_list : TK_UNQUOTED_STR",
"network_list : network_list ',' TK_QUOTED_STR",
"network_list : TK_QUOTED_STR",
"network_entry : TK_UNQUOTED_STR '{' network_statements '}'",
"network_entry : TK_NUMBER '{' network_statements '}'",
"network_entry : TK_QUOTED_STR '{' network_statements '}'",
"network_entry : TK_UNQUOTED_STR '{' '}'",
"network_entry : TK_QUOTED_STR '{' '}'",
"network_entry : TK_NUMBER '{' '}'",
"network_statements : network_statements network_parameter",
"network_statements : network_statements eap_type_statement",
"network_statements : network_parameter",
"network_statements : eap_type_statement",
"network_parameter : network_type_parameter",
"network_parameter : network_priority",
"network_parameter : network_use_tnc",
"network_parameter : network_wpa_group_enc_type",
"network_parameter : network_wpa_pairwise_enc_type",
"network_parameter : network_force_eapol_ver",
"network_parameter : network_identity_parameter",
"network_parameter : network_dest_mac_parameter",
"network_parameter : network_allow_parameter",
"network_parameter : network_assoc_type",
"network_parameter : network_control_wireless",
"network_priority : TK_PRIORITY '=' TK_NUMBER",
"network_type_parameter : TK_TYPE '=' TK_WIRELESS",
"network_type_parameter : TK_TYPE '=' TK_WIRED",
"network_type_parameter : TK_TYPE '=' TK_UNQUOTED_STR",
"network_wpa_group_enc_type : TK_WPA_GROUP_CRYPT '=' TK_WEP40",
"network_wpa_group_enc_type : TK_WPA_GROUP_CRYPT '=' TK_TKIP",
"network_wpa_group_enc_type : TK_WPA_GROUP_CRYPT '=' TK_WRAP",
"network_wpa_group_enc_type : TK_WPA_GROUP_CRYPT '=' TK_CCMP",
"network_wpa_group_enc_type : TK_WPA_GROUP_CRYPT '=' TK_WEP104",
"network_wpa_pairwise_enc_type : TK_WPA_PAIRWISE_CRYPT '=' TK_WEP40",
"network_wpa_pairwise_enc_type : TK_WPA_PAIRWISE_CRYPT '=' TK_TKIP",
"network_wpa_pairwise_enc_type : TK_WPA_PAIRWISE_CRYPT '=' TK_WRAP",
"network_wpa_pairwise_enc_type : TK_WPA_PAIRWISE_CRYPT '=' TK_CCMP",
"network_wpa_pairwise_enc_type : TK_WPA_PAIRWISE_CRYPT '=' TK_WEP104",
"network_force_eapol_ver : TK_FORCE_EAPOL_VER '=' TK_NUMBER",
"network_assoc_type : TK_ASSOCIATION_TYPE '=' TK_ASSOC_OPEN",
"network_assoc_type : TK_ASSOCIATION_TYPE '=' TK_ASSOC_SHARED",
"network_assoc_type : TK_ASSOCIATION_TYPE '=' TK_ASSOC_LEAP",
"network_control_wireless : TK_CONTROL_WIRELESS '=' TK_YES",
"network_control_wireless : TK_CONTROL_WIRELESS '=' TK_NO",
"network_control_wireless : TK_CONTROL_WIRELESS '=' TK_UNQUOTED_STR",
"network_identity_parameter : TK_IDENTITY '=' TK_IDENTITY_VAL",
"network_identity_parameter : TK_IDENTITY '=' TK_QUOTED_STR",
"network_identity_parameter : TK_IDENTITY '=' TK_UNQUOTED_STR",
"network_use_tnc : TK_USE_TNC '=' TK_YES",
"network_use_tnc : TK_USE_TNC '=' TK_NO",
"network_dest_mac_parameter : TK_DEST_MAC '=' TK_MACADDRESS",
"network_allow_parameter : TK_ALLOW_TYPES '=' TK_ALL",
"network_allow_parameter : TK_ALLOW_TYPES '=' eap_type_list",
"eap_type_statement : eap_tls_statement",
"eap_type_statement : eap_md5_statement",
"eap_type_statement : eap_ttls_statement",
"eap_type_statement : static_wep_statement",
"eap_type_statement : initial_wep_statement",
"eap_type_statement : eap_leap_statement",
"eap_type_statement : eap_mschapv2_statement",
"eap_type_statement : eap_peap_statement",
"eap_type_statement : eap_sim_statement",
"eap_type_statement : eap_aka_statement",
"eap_type_statement : wpa_psk_statement",
"eap_type_list : eap_type_list ',' eap_type",
"eap_type_list : eap_type",
"eap_type : TK_EAP_TLS",
"eap_type : TK_EAP_MD5",
"eap_type : TK_EAP_TTLS",
"eap_type : TK_EAP_LEAP",
"eap_type : TK_EAP_MSCHAPV2",
"eap_type : TK_EAP_PEAP",
"eap_type : TK_EAP_SIM",
"eap_type : TK_EAP_AKA",
"eap_type : TK_EAP_GTC",
"eap_type : TK_EAP_OTP",
"static_wep_statement : TK_STATIC_WEP '{' static_wep_params '}'",
"static_wep_statement : TK_STATIC_WEP '{' '}'",
"static_wep_params : static_wep_params static_wep_param",
"static_wep_params : static_wep_param",
"static_wep_param : TK_STATIC_KEY1 '=' TK_QUOTED_STR",
"static_wep_param : TK_STATIC_KEY2 '=' TK_QUOTED_STR",
"static_wep_param : TK_STATIC_KEY3 '=' TK_QUOTED_STR",
"static_wep_param : TK_STATIC_KEY4 '=' TK_QUOTED_STR",
"static_wep_param : TK_WEP_TX_KEY '=' TK_NUMBER",
"initial_wep_statement : TK_INITIAL_WEP '{' initial_wep_params '}'",
"initial_wep_statement : TK_INITIAL_WEP '{' '}'",
"initial_wep_params : initial_wep_params initial_wep_param",
"initial_wep_params : initial_wep_param",
"initial_wep_param : TK_STATIC_KEY1 '=' TK_QUOTED_STR",
"initial_wep_param : TK_STATIC_KEY2 '=' TK_QUOTED_STR",
"initial_wep_param : TK_STATIC_KEY3 '=' TK_QUOTED_STR",
"initial_wep_param : TK_STATIC_KEY4 '=' TK_QUOTED_STR",
"initial_wep_param : TK_WEP_TX_KEY '=' TK_NUMBER",
"eap_tls_statement : TK_EAP_TLS '{' eap_tls_params '}'",
"eap_tls_statement : TK_EAP_TLS '{' '}'",
"eap_tls_params : eap_tls_params eap_tls_param",
"eap_tls_params : eap_tls_param",
"smartcard_section : TK_SMARTCARD '{' smartcard_params '}'",
"smartcard_params : smartcard_param smartcard_params",
"smartcard_params : smartcard_param",
"smartcard_param : TK_ENGINE_ID '=' TK_UNQUOTED_STR",
"smartcard_param : TK_OPENSC_SO_PATH '=' TK_UNQUOTED_STR",
"smartcard_param : TK_OPENSC_SO_PATH '=' TK_QUOTED_STR",
"smartcard_param : TK_KEYID '=' TK_UNQUOTED_STR",
"smartcard_param : TK_KEYID '=' TK_NUMBER",
"eap_tls_param : TK_USER_CERT '=' TK_UNQUOTED_STR",
"eap_tls_param : TK_USER_CERT '=' TK_QUOTED_STR",
"eap_tls_param : TK_USER_KEY '=' TK_UNQUOTED_STR",
"eap_tls_param : TK_USER_KEY '=' TK_QUOTED_STR",
"eap_tls_param : TK_USER_KEY_PASS '=' TK_PASS",
"eap_tls_param : TK_USER_KEY_PASS '=' TK_QUOTED_STR",
"eap_tls_param : TK_USER_KEY_PASS '=' TK_UNQUOTED_STR",
"eap_tls_param : TK_SESSION_RESUME '=' TK_YES",
"eap_tls_param : TK_SESSION_RESUME '=' TK_NO",
"eap_tls_param : TK_SESSION_RESUME '=' TK_UNQUOTED_STR",
"eap_tls_param : TK_ROOT_CERT '=' TK_UNQUOTED_STR",
"eap_tls_param : TK_ROOT_CERT '=' TK_QUOTED_STR",
"eap_tls_param : TK_ROOT_DIR '=' TK_UNQUOTED_STR",
"eap_tls_param : TK_ROOT_DIR '=' TK_QUOTED_STR",
"eap_tls_param : TK_CRL_DIR '=' TK_UNQUOTED_STR",
"eap_tls_param : TK_CRL_DIR '=' TK_QUOTED_STR",
"eap_tls_param : TK_CHUNK_SIZE '=' TK_NUMBER",
"eap_tls_param : TK_RANDOM_FILE '=' TK_UNQUOTED_STR",
"eap_tls_param : TK_RANDOM_FILE '=' TK_QUOTED_STR",
"eap_tls_param : smartcard_section",
"eap_md5_statement : TK_EAP_MD5 '{' eap_md5_params '}'",
"eap_md5_statement : TK_EAP_MD5 '{' '}'",
"eap_md5_params : eap_md5_params eap_md5_param",
"eap_md5_params : eap_md5_param",
"eap_md5_param : TK_USERNAME '=' TK_USERNAME_VAL",
"eap_md5_param : TK_USERNAME '=' TK_UNQUOTED_STR",
"eap_md5_param : TK_USERNAME '=' TK_QUOTED_STR",
"eap_md5_param : TK_PASSWORD '=' TK_PASS",
"eap_md5_param : TK_PASSWORD '=' TK_UNQUOTED_STR",
"eap_md5_param : TK_PASSWORD '=' TK_QUOTED_STR",
"eap_ttls_statement : TK_EAP_TTLS '{' eap_ttls_params '}'",
"eap_ttls_statement : TK_EAP_TTLS '{' '}'",
"eap_ttls_params : eap_ttls_params eap_ttls_param",
"eap_ttls_params : eap_ttls_param",
"eap_ttls_param : TK_USER_CERT '=' TK_UNQUOTED_STR",
"eap_ttls_param : TK_USER_CERT '=' TK_QUOTED_STR",
"eap_ttls_param : TK_USER_KEY '=' TK_UNQUOTED_STR",
"eap_ttls_param : TK_USER_KEY '=' TK_QUOTED_STR",
"eap_ttls_param : TK_USER_KEY_PASS '=' TK_PASS",
"eap_ttls_param : TK_USER_KEY_PASS '=' TK_UNQUOTED_STR",
"eap_ttls_param : TK_USER_KEY_PASS '=' TK_QUOTED_STR",
"eap_ttls_param : TK_ROOT_CERT '=' TK_UNQUOTED_STR",
"eap_ttls_param : TK_ROOT_CERT '=' TK_QUOTED_STR",
"eap_ttls_param : TK_ROOT_DIR '=' TK_UNQUOTED_STR",
"eap_ttls_param : TK_ROOT_DIR '=' TK_QUOTED_STR",
"eap_ttls_param : TK_CRL_DIR '=' TK_UNQUOTED_STR",
"eap_ttls_param : TK_CRL_DIR '=' TK_QUOTED_STR",
"eap_ttls_param : TK_CHUNK_SIZE '=' TK_NUMBER",
"eap_ttls_param : TK_RANDOM_FILE '=' TK_UNQUOTED_STR",
"eap_ttls_param : TK_RANDOM_FILE '=' TK_QUOTED_STR",
"eap_ttls_param : TK_SESSION_RESUME '=' TK_YES",
"eap_ttls_param : TK_SESSION_RESUME '=' TK_NO",
"eap_ttls_param : TK_SESSION_RESUME '=' TK_UNQUOTED_STR",
"eap_ttls_param : TK_CNCHECK '=' TK_UNQUOTED_STR",
"eap_ttls_param : TK_CNEXACT '=' TK_YES",
"eap_ttls_param : TK_CNEXACT '=' TK_NO",
"eap_ttls_param : TK_PHASE2_TYPE '=' TK_PAP",
"eap_ttls_param : TK_PHASE2_TYPE '=' TK_CHAP",
"eap_ttls_param : TK_PHASE2_TYPE '=' TK_MSCHAP",
"eap_ttls_param : TK_PHASE2_TYPE '=' TK_MSCHAPV2",
"eap_ttls_param : TK_PHASE2_TYPE '=' TK_EAP_MD5",
"eap_ttls_param : eap_ttls_phase2_statement",
"eap_ttls_phase2_statement : phase2_pap_statement",
"eap_ttls_phase2_statement : phase2_chap_statement",
"eap_ttls_phase2_statement : phase2_mschap_statement",
"eap_ttls_phase2_statement : phase2_mschapv2_statement",
"eap_ttls_phase2_statement : eap_ttls_phase2_eap_statement",
"phase2_pap_statement : TK_PAP '{' phase2_pap_params '}'",
"phase2_pap_params : phase2_pap_params phase2_pap_param",
"phase2_pap_params : phase2_pap_param",
"phase2_pap_param : TK_USERNAME '=' TK_USERNAME_VAL",
"phase2_pap_param : TK_USERNAME '=' TK_UNQUOTED_STR",
"phase2_pap_param : TK_USERNAME '=' TK_QUOTED_STR",
"phase2_pap_param : TK_PASSWORD '=' TK_PASS",
"phase2_pap_param : TK_PASSWORD '=' TK_UNQUOTED_STR",
"phase2_pap_param : TK_PASSWORD '=' TK_QUOTED_STR",
"phase2_chap_statement : TK_CHAP '{' phase2_chap_params '}'",
"phase2_chap_params : phase2_chap_params phase2_chap_param",
"phase2_chap_params : phase2_chap_param",
"phase2_chap_param : TK_USERNAME '=' TK_USERNAME_VAL",
"phase2_chap_param : TK_USERNAME '=' TK_UNQUOTED_STR",
"phase2_chap_param : TK_USERNAME '=' TK_QUOTED_STR",
"phase2_chap_param : TK_PASSWORD '=' TK_PASS",
"phase2_chap_param : TK_PASSWORD '=' TK_UNQUOTED_STR",
"phase2_chap_param : TK_PASSWORD '=' TK_QUOTED_STR",
"phase2_mschap_statement : TK_MSCHAP '{' phase2_mschap_params '}'",
"phase2_mschap_params : phase2_mschap_params phase2_mschap_param",
"phase2_mschap_params : phase2_mschap_param",
"phase2_mschap_param : TK_USERNAME '=' TK_USERNAME_VAL",
"phase2_mschap_param : TK_USERNAME '=' TK_UNQUOTED_STR",
"phase2_mschap_param : TK_USERNAME '=' TK_QUOTED_STR",
"phase2_mschap_param : TK_PASSWORD '=' TK_PASS",
"phase2_mschap_param : TK_PASSWORD '=' TK_UNQUOTED_STR",
"phase2_mschap_param : TK_PASSWORD '=' TK_QUOTED_STR",
"phase2_mschapv2_statement : TK_MSCHAPV2 '{' phase2_mschapv2_params '}'",
"phase2_mschapv2_params : phase2_mschapv2_params phase2_mschapv2_param",
"phase2_mschapv2_params : phase2_mschapv2_param",
"phase2_mschapv2_param : TK_USERNAME '=' TK_USERNAME_VAL",
"phase2_mschapv2_param : TK_USERNAME '=' TK_UNQUOTED_STR",
"phase2_mschapv2_param : TK_USERNAME '=' TK_QUOTED_STR",
"phase2_mschapv2_param : TK_PASSWORD '=' TK_PASS",
"phase2_mschapv2_param : TK_PASSWORD '=' TK_UNQUOTED_STR",
"phase2_mschapv2_param : TK_PASSWORD '=' TK_QUOTED_STR",
"eap_ttls_phase2_eap_statement : eap_md5_statement",
"eap_leap_statement : TK_EAP_LEAP '{' eap_leap_params '}'",
"eap_leap_statement : TK_EAP_LEAP '{' '}'",
"eap_leap_params : eap_leap_params eap_leap_param",
"eap_leap_params : eap_leap_param",
"eap_leap_param : TK_USERNAME '=' TK_USERNAME_VAL",
"eap_leap_param : TK_USERNAME '=' TK_UNQUOTED_STR",
"eap_leap_param : TK_USERNAME '=' TK_QUOTED_STR",
"eap_leap_param : TK_PASSWORD '=' TK_PASS",
"eap_leap_param : TK_PASSWORD '=' TK_UNQUOTED_STR",
"eap_leap_param : TK_PASSWORD '=' TK_QUOTED_STR",
"eap_mschapv2_statement : TK_EAP_MSCHAPV2 '{' eap_mschapv2_params '}'",
"eap_mschapv2_statement : TK_EAP_MSCHAPV2 '{' '}'",
"eap_mschapv2_params : eap_mschapv2_params eap_mschapv2_param",
"eap_mschapv2_params : eap_mschapv2_param",
"eap_mschapv2_param : TK_USERNAME '=' TK_USERNAME_VAL",
"eap_mschapv2_param : TK_USERNAME '=' TK_UNQUOTED_STR",
"eap_mschapv2_param : TK_USERNAME '=' TK_QUOTED_STR",
"eap_mschapv2_param : TK_PASSWORD '=' TK_PASS",
"eap_mschapv2_param : TK_PASSWORD '=' TK_UNQUOTED_STR",
"eap_mschapv2_param : TK_PASSWORD '=' TK_QUOTED_STR",
"eap_mschapv2_param : TK_MSCHAPV2_HASH_PWD '=' TK_UNQUOTED_STR",
"eap_peap_statement : TK_EAP_PEAP '{' eap_peap_params '}'",
"eap_peap_statement : TK_EAP_PEAP '{' '}'",
"eap_peap_params : eap_peap_params eap_peap_param",
"eap_peap_params : eap_peap_param",
"eap_peap_param : TK_IDENTITY '=' TK_IDENTITY_VAL",
"eap_peap_param : TK_IDENTITY '=' TK_UNQUOTED_STR",
"eap_peap_param : TK_IDENTITY '=' TK_QUOTED_STR",
"eap_peap_param : TK_USER_CERT '=' TK_UNQUOTED_STR",
"eap_peap_param : TK_USER_CERT '=' TK_QUOTED_STR",
"eap_peap_param : TK_USER_KEY '=' TK_UNQUOTED_STR",
"eap_peap_param : TK_USER_KEY '=' TK_QUOTED_STR",
"eap_peap_param : TK_USER_KEY_PASS '=' TK_PASS",
"eap_peap_param : TK_USER_KEY_PASS '=' TK_UNQUOTED_STR",
"eap_peap_param : TK_USER_KEY_PASS '=' TK_QUOTED_STR",
"eap_peap_param : TK_ROOT_CERT '=' TK_UNQUOTED_STR",
"eap_peap_param : TK_ROOT_CERT '=' TK_QUOTED_STR",
"eap_peap_param : TK_ROOT_DIR '=' TK_UNQUOTED_STR",
"eap_peap_param : TK_ROOT_DIR '=' TK_QUOTED_STR",
"eap_peap_param : TK_CRL_DIR '=' TK_UNQUOTED_STR",
"eap_peap_param : TK_CRL_DIR '=' TK_QUOTED_STR",
"eap_peap_param : TK_SESSION_RESUME '=' TK_YES",
"eap_peap_param : TK_SESSION_RESUME '=' TK_NO",
"eap_peap_param : TK_SESSION_RESUME '=' TK_UNQUOTED_STR",
"eap_peap_param : TK_PEAPV1_PROPER_KEYING '=' TK_YES",
"eap_peap_param : TK_PEAPV1_PROPER_KEYING '=' TK_NO",
"eap_peap_param : TK_PEAPV1_PROPER_KEYING '=' TK_UNQUOTED_STR",
"eap_peap_param : TK_INNER_ID '=' TK_UNQUOTED_STR",
"eap_peap_param : TK_INNER_ID '=' TK_QUOTED_STR",
"eap_peap_param : TK_CHUNK_SIZE '=' TK_NUMBER",
"eap_peap_param : TK_CNCHECK '=' TK_UNQUOTED_STR",
"eap_peap_param : TK_CNEXACT '=' TK_YES",
"eap_peap_param : TK_CNEXACT '=' TK_NO",
"eap_peap_param : TK_RANDOM_FILE '=' TK_UNQUOTED_STR",
"eap_peap_param : TK_RANDOM_FILE '=' TK_QUOTED_STR",
"eap_peap_param : TK_IAS_QUIRK '=' TK_YES",
"eap_peap_param : TK_IAS_QUIRK '=' TK_NO",
"eap_peap_param : TK_IAS_QUIRK '=' TK_UNQUOTED_STR",
"eap_peap_param : eap_peap_allow_parameter",
"eap_peap_param : eap_peap_phase2_statement",
"eap_peap_allow_parameter : TK_ALLOW_TYPES '=' TK_ALL",
"eap_peap_allow_parameter : TK_ALLOW_TYPES '=' eap_peap_phase2_type_list",
"eap_peap_phase2_type_list : eap_peap_phase2_type_list ',' eap_peap_phase2_type",
"eap_peap_phase2_type_list : eap_peap_phase2_type",
"eap_peap_phase2_type : TK_EAP_MSCHAPV2",
"eap_peap_phase2_type : TK_EAP_MD5",
"eap_peap_phase2_type : TK_EAP_SIM",
"eap_peap_phase2_type : TK_EAP_OTP",
"eap_peap_phase2_type : TK_EAP_GTC",
"eap_peap_phase2_statement : eap_mschapv2_statement",
"eap_peap_phase2_statement : eap_md5_statement",
"eap_peap_phase2_statement : eap_sim_statement",
"eap_sim_statement : TK_EAP_SIM '{' eap_sim_params '}'",
"eap_sim_statement : TK_EAP_SIM '{' '}'",
"eap_sim_params : eap_sim_params eap_sim_param",
"eap_sim_params : eap_sim_param",
"eap_sim_param : TK_USERNAME '=' TK_USERNAME_VAL",
"eap_sim_param : TK_USERNAME '=' TK_UNQUOTED_STR",
"eap_sim_param : TK_USERNAME '=' TK_QUOTED_STR",
"eap_sim_param : TK_PASSWORD '=' TK_PASS",
"eap_sim_param : TK_PASSWORD '=' TK_UNQUOTED_STR",
"eap_sim_param : TK_PASSWORD '=' TK_QUOTED_STR",
"eap_sim_param : TK_AUTO_REALM '=' TK_YES",
"eap_sim_param : TK_AUTO_REALM '=' TK_NO",
"eap_sim_param : TK_AUTO_REALM '=' TK_UNQUOTED_STR",
"eap_aka_statement : TK_EAP_AKA '{' eap_aka_params '}'",
"eap_aka_statement : TK_EAP_AKA '{' '}'",
"eap_aka_params : eap_aka_params eap_aka_param",
"eap_aka_params : eap_aka_param",
"eap_aka_param : TK_USERNAME '=' TK_USERNAME_VAL",
"eap_aka_param : TK_USERNAME '=' TK_UNQUOTED_STR",
"eap_aka_param : TK_USERNAME '=' TK_QUOTED_STR",
"eap_aka_param : TK_PASSWORD '=' TK_PASS",
"eap_aka_param : TK_PASSWORD '=' TK_UNQUOTED_STR",
"eap_aka_param : TK_PASSWORD '=' TK_QUOTED_STR",
"eap_aka_param : TK_AUTO_REALM '=' TK_YES",
"eap_aka_param : TK_AUTO_REALM '=' TK_NO",
"eap_aka_param : TK_AUTO_REALM '=' TK_UNQUOTED_STR",
"wpa_psk_statement : TK_WPA_PSK '{' wpa_psk_params '}'",
"wpa_psk_statement : TK_WPA_PSK '{' '}'",
"wpa_psk_params : wpa_psk_params wpa_psk_param",
"wpa_psk_params : wpa_psk_param",
"wpa_psk_param : TK_WPA_PSK_KEY '=' TK_UNQUOTED_STR",
"wpa_psk_param : TK_WPA_PSK_KEY '=' TK_QUOTED_STR",
"wpa_psk_param : TK_WPA_PSK_HEX_KEY '=' TK_UNQUOTED_STR",
};
#endif
#ifdef YYSTACKSIZE
#undef YYMAXDEPTH
#define YYMAXDEPTH YYSTACKSIZE
#else
#ifdef YYMAXDEPTH
#define YYSTACKSIZE YYMAXDEPTH
#else
#define YYSTACKSIZE 500
#define YYMAXDEPTH 500
#endif
#endif
int yydebug;
int yynerrs;
int yyerrflag;
int yychar;
short *yyssp;
YYSTYPE *yyvsp;
YYSTYPE yyval;
YYSTYPE yylval;
short yyss[YYSTACKSIZE];
YYSTYPE yyvs[YYSTACKSIZE];
#define yystacksize YYSTACKSIZE
#define YYABORT goto yyabort
#define YYREJECT goto yyabort
#define YYACCEPT goto yyaccept
#define YYERROR goto yyerrlab
int
yyparse(void)
{
    register int yym, yyn, yystate;
#if YYDEBUG
    register char *yys;
    extern char *getenv();

    if (yys = getenv("YYDEBUG"))
    {
        yyn = *yys;
        if (yyn >= '0' && yyn <= '9')
            yydebug = yyn - '0';
    }
#endif

    yynerrs = 0;
    yyerrflag = 0;
    yychar = (-1);

    yyssp = yyss;
    yyvsp = yyvs;
    *yyssp = yystate = 0;

yyloop:
    if ((yyn = yydefred[yystate]) != 0) goto yyreduce;
    if (yychar < 0)
    {
        if ((yychar = yylex()) < 0) yychar = 0;
#if YYDEBUG
        if (yydebug)
        {
            yys = 0;
            if (yychar <= YYMAXTOKEN) yys = yyname[yychar];
            if (!yys) yys = "illegal-symbol";
            printf("%sdebug: state %d, reading %d (%s)\n",
                    YYPREFIX, yystate, yychar, yys);
        }
#endif
    }
    if ((yyn = yysindex[yystate]) && (yyn += yychar) >= 0 &&
            yyn <= YYTABLESIZE && yycheck[yyn] == yychar)
    {
#if YYDEBUG
        if (yydebug)
            printf("%sdebug: state %d, shifting to state %d\n",
                    YYPREFIX, yystate, yytable[yyn]);
#endif
        if (yyssp >= yyss + yystacksize - 1)
        {
            goto yyoverflow;
        }
        *++yyssp = yystate = yytable[yyn];
        *++yyvsp = yylval;
        yychar = (-1);
        if (yyerrflag > 0)  --yyerrflag;
        goto yyloop;
    }
    if ((yyn = yyrindex[yystate]) && (yyn += yychar) >= 0 &&
            yyn <= YYTABLESIZE && yycheck[yyn] == yychar)
    {
        yyn = yytable[yyn];
        goto yyreduce;
    }
    if (yyerrflag) goto yyinrecovery;
#ifdef lint
    goto yynewerror;
#endif
yynewerror:
    yyerror("syntax error");
#ifdef lint
    goto yyerrlab;
#endif
yyerrlab:
    ++yynerrs;
yyinrecovery:
    if (yyerrflag < 3)
    {
        yyerrflag = 3;
        for (;;)
        {
            if ((yyn = yysindex[*yyssp]) && (yyn += YYERRCODE) >= 0 &&
                    yyn <= YYTABLESIZE && yycheck[yyn] == YYERRCODE)
            {
#if YYDEBUG
                if (yydebug)
                    printf("%sdebug: state %d, error recovery shifting\
 to state %d\n", YYPREFIX, *yyssp, yytable[yyn]);
#endif
                if (yyssp >= yyss + yystacksize - 1)
                {
                    goto yyoverflow;
                }
                *++yyssp = yystate = yytable[yyn];
                *++yyvsp = yylval;
                goto yyloop;
            }
            else
            {
#if YYDEBUG
                if (yydebug)
                    printf("%sdebug: error recovery discarding state %d\n",
                            YYPREFIX, *yyssp);
#endif
                if (yyssp <= yyss) goto yyabort;
                --yyssp;
                --yyvsp;
            }
        }
    }
    else
    {
        if (yychar == 0) goto yyabort;
#if YYDEBUG
        if (yydebug)
        {
            yys = 0;
            if (yychar <= YYMAXTOKEN) yys = yyname[yychar];
            if (!yys) yys = "illegal-symbol";
            printf("%sdebug: state %d, error recovery discards token %d (%s)\n",
                    YYPREFIX, yystate, yychar, yys);
        }
#endif
        yychar = (-1);
        goto yyloop;
    }
yyreduce:
#if YYDEBUG
    if (yydebug)
        printf("%sdebug: state %d, reducing by rule %d (%s)\n",
                YYPREFIX, yystate, yyn, yyrule[yyn]);
#endif
    yym = yylen[yyn];
    yyval = yyvsp[1-yym];
    switch (yyn)
    {
case 1:
#line 389 "config_grammar.y"
{
                     config_info = tmp_config;
                     tmp_config = NULL;
                  }
break;
case 2:
#line 393 "config_grammar.y"
{ 
                      printf("Error: No networks defined.\n"); 
		      CLEAN_EXIT;
		    }
break;
case 3:
#line 397 "config_grammar.y"
{
		      printf("Error: No globals defined.\n"); 
		      cleanup_parse();
		      return XECONFIGPARSEFAIL;
                    }
break;
case 4:
#line 402 "config_grammar.y"
{
		    printf("General Parse error!\n");
 		      cleanup_parse();
		      return XECONFIGPARSEFAIL; }
break;
case 9:
#line 416 "config_grammar.y"
{
                      set_current_globals();
                      parameter_debug("network_list: all\n");
		      /* do nothing. leave null*/
                    }
break;
case 10:
#line 421 "config_grammar.y"
{
		    /* done below. nothing to do here*/
  		    }
break;
case 11:
#line 424 "config_grammar.y"
{
 		     set_current_globals();
		     parameter_debug("Default network: \"%s\"\n", yyvsp[0].str);
		     if (tmp_config->globals->default_net)
		       free(yyvsp[0].str);
		     else
		       tmp_config->globals->default_net = yyvsp[0].str;
		  }
break;
case 12:
#line 432 "config_grammar.y"
{
 		     set_current_globals();
		     parameter_debug("Default network: \"%s\"\n", yyvsp[0].str);
		     if (tmp_config->globals->default_net)
		       free(yyvsp[0].str);
		     else
		       tmp_config->globals->default_net = yyvsp[0].str;
		  }
break;
case 13:
#line 440 "config_grammar.y"
{
		    set_current_globals();
		    parameter_debug("Friendly Warnings: YES\n");
		    UNSET_FLAG(tmp_config->globals->flags, 
			     CONFIG_GLOBALS_NO_FRIENDLY_WARNINGS);
                    }
break;
case 14:
#line 446 "config_grammar.y"
{
		    set_current_globals();
		    parameter_debug("Friendly Warnings: NO\n");
		    SET_FLAG(tmp_config->globals->flags,
			     CONFIG_GLOBALS_NO_FRIENDLY_WARNINGS);
                    }
break;
case 15:
#line 452 "config_grammar.y"
{
		    set_current_globals();
		    printf("Invalid vale for \"friendly_warnings\" option! "
			   "defaulting to YES.\n");
		    parameter_debug("Friendly Warnings: Defaulting to YES"
				    " (Invalid value \"%s\")\n", yyvsp[0].str);
                    UNSET_FLAG(tmp_config->globals->flags,
		             CONFIG_GLOBALS_NO_FRIENDLY_WARNINGS);
                    }
break;
case 16:
#line 461 "config_grammar.y"
{
                    set_current_globals();
                    parameter_debug("Firmware roaming.\n");
                    SET_FLAG(tmp_config->globals->flags, 
			     CONFIG_GLOBALS_FIRMWARE_ROAM);
                    }
break;
case 17:
#line 467 "config_grammar.y"
{
                    set_current_globals();      
                    parameter_debug("Xsupplicant roaming.\n");
                    UNSET_FLAG(tmp_config->globals->flags, 
			       CONFIG_GLOBALS_FIRMWARE_ROAM);
                    }
break;
case 18:
#line 473 "config_grammar.y"
{
                    set_current_globals();
                    parameter_debug("Xsupplicant roaming.\n");
                    printf("Invalid setting for 'roaming' value.  "
                    	       "Defaulting to Xsupplicant based roaming.\n");
                    UNSET_FLAG(tmp_config->globals->flags, 
			       CONFIG_GLOBALS_FIRMWARE_ROAM);
                    }
break;
case 19:
#line 481 "config_grammar.y"
{
                    set_current_globals();
                    parameter_debug("Passive Scanning : Yes\n");
                    SET_FLAG(tmp_config->globals->flags,
                             CONFIG_GLOBALS_PASSIVE_SCAN);
                    }
break;
case 20:
#line 487 "config_grammar.y"
{
                    set_current_globals();
                    parameter_debug("Passive Scanning : No\n");
                    UNSET_FLAG(tmp_config->globals->flags,
	                       CONFIG_GLOBALS_PASSIVE_SCAN);
                    }
break;
case 21:
#line 493 "config_grammar.y"
{
                    set_current_globals();
                    parameter_debug("Passive Scanning : Yes\n");
                    printf("Invalid setting for 'passive_scanning'."
	                         " Defaulting to yes.\n");
		    SET_FLAG(tmp_config->globals->flags,
			     CONFIG_GLOBALS_PASSIVE_SCAN);
                    }
break;
case 22:
#line 501 "config_grammar.y"
{
                    set_current_globals();
                    parameter_debug("Use EAP Hints : Yes\n");
                    UNSET_FLAG(tmp_config->globals->flags,
			       CONFIG_GLOBALS_NO_EAP_HINTS);
                    }
break;
case 23:
#line 507 "config_grammar.y"
{
                    set_current_globals();
                    parameter_debug("Use EAP Hints : No\n");
                    SET_FLAG(tmp_config->globals->flags,
			     CONFIG_GLOBALS_NO_EAP_HINTS);
                    }
break;
case 24:
#line 513 "config_grammar.y"
{
                    set_current_globals();
                    parameter_debug("Use EAP Hints : Yes\n");
                    printf("Invalid setting for 'use_eap_hints'."
	                         " Defaulting to yes.\n");
		    UNSET_FLAG(tmp_config->globals->flags,
			       CONFIG_GLOBALS_NO_EAP_HINTS);
                    }
break;
case 25:
#line 521 "config_grammar.y"
{
                    set_current_globals();
                    parameter_debug("Passive Scan Timer: %d\n", yyvsp[0].num);
                    tmp_config->globals->passive_timeout = yyvsp[0].num;
                    }
break;
case 26:
#line 526 "config_grammar.y"
{
		    set_current_globals();
		    parameter_debug("Scan timeout: %d\n", yyvsp[0].num);
		    tmp_config->globals->active_timeout = yyvsp[0].num;
		  }
break;
case 27:
#line 531 "config_grammar.y"
{
		     set_current_globals();
		     parameter_debug("Logfile: \"%s\"\n", yyvsp[0].str);
		     if (tmp_config->globals->logfile)
		       {
			 free(yyvsp[0].str);
			 tmp_config->globals->logfile = NULL;
		       }
		     else
		       tmp_config->globals->logfile = yyvsp[0].str;
		    }
break;
case 28:
#line 542 "config_grammar.y"
{
		    set_current_globals();
		    parameter_debug("Logfile: \"%s\"\n", yyvsp[0].str);
		    if (tmp_config->globals->logfile)
		      {
			free(yyvsp[0].str);
			tmp_config->globals->logfile = NULL;
		      }
		    else
		      tmp_config->globals->logfile = yyvsp[0].str;
		  }
break;
case 29:
#line 553 "config_grammar.y"
{
		    set_current_globals();
                    parameter_debug("Default Interface: \"%s\"\n", yyvsp[0].str);
		    if (tmp_config->globals->default_int)
		      {
			free(yyvsp[0].str);
			tmp_config->globals->default_int = NULL;
		      }
		    else
		      tmp_config->globals->default_int = yyvsp[0].str;
		    }
break;
case 30:
#line 564 "config_grammar.y"
{
		    set_current_globals();
		    tmp_config->globals->stale_key_timeout = yyvsp[0].num;
		    }
break;
case 31:
#line 568 "config_grammar.y"
{
		    set_current_globals();
		    printf("Invalid value for stale key "
				 "timer.  Leaving at the default of 10 minutes"
				 "!\n");
		    }
break;
case 32:
#line 574 "config_grammar.y"
{
                    set_current_globals();
                    SET_FLAG(tmp_config->globals->flags, CONFIG_GLOBALS_ASSOC_AUTO);
                  }
break;
case 33:
#line 578 "config_grammar.y"
{
                    set_current_globals();
                    UNSET_FLAG(tmp_config->globals->flags, CONFIG_GLOBALS_ASSOC_AUTO);
                  }
break;
case 34:
#line 582 "config_grammar.y"
{
                    set_current_globals();
                    printf("Invalid setting for 'association'! "
	                         "Leaving at default setting.\n");
                    UNSET_FLAG(tmp_config->globals->flags, CONFIG_GLOBALS_ASSOC_AUTO);
                  }
break;
case 35:
#line 588 "config_grammar.y"
{
                    set_current_globals();
                    tmp_config->globals->assoc_timeout = yyvsp[0].num;
                  }
break;
case 36:
#line 592 "config_grammar.y"
{
                    set_current_globals();
                    printf("Invalid setting for association_timeout."
	                         " We will use the default setting.\n");
                  }
break;
case 37:
#line 597 "config_grammar.y"
{
		     set_current_globals();
		     if (!TEST_FLAG(tmp_config->globals->flags, CONFIG_GLOBALS_AUTH_PER)) {
		       SET_FLAG(tmp_config->globals->flags, CONFIG_GLOBALS_AUTH_PER);
		       tmp_config->globals->auth_period = yyvsp[0].num;
		     }
                    }
break;
case 38:
#line 604 "config_grammar.y"
{
		     set_current_globals();
		     if (!TEST_FLAG(tmp_config->globals->flags, CONFIG_GLOBALS_HELD_PER)) {
		       SET_FLAG(tmp_config->globals->flags, CONFIG_GLOBALS_HELD_PER);
		       tmp_config->globals->held_period = yyvsp[0].num;
		     }
                    }
break;
case 39:
#line 611 "config_grammar.y"
{
		     set_current_globals();
		     if (!TEST_FLAG(tmp_config->globals->flags, CONFIG_GLOBALS_MAX_STARTS)) {
		       SET_FLAG(tmp_config->globals->flags, CONFIG_GLOBALS_MAX_STARTS);
		       tmp_config->globals->max_starts = yyvsp[0].num;
		     }
                    }
break;
case 40:
#line 618 "config_grammar.y"
{
		     set_current_globals();
		     SET_FLAG(tmp_config->globals->flags,
			      CONFIG_GLOBALS_ALLMULTI);
                    }
break;
case 41:
#line 623 "config_grammar.y"
{
		     set_current_globals();
		     UNSET_FLAG(tmp_config->globals->flags,
				CONFIG_GLOBALS_ALLMULTI);
                    }
break;
case 42:
#line 628 "config_grammar.y"
{
                     printf("Unknown value for ALLMULTI = \"%s\"! Defaulting to YES! (Line : %d)\n", yyvsp[0].str, config_linenum);
		     set_current_globals();
		     SET_FLAG(tmp_config->globals->flags,
			      CONFIG_GLOBALS_ALLMULTI);
                    }
break;
case 43:
#line 634 "config_grammar.y"
{
		    set_current_globals();
		    if (!tmp_config->globals->ipc_group_name)
			  tmp_config->globals->ipc_group_name = yyvsp[0].str;
			else
			  free(yyvsp[0].str);
                      }
break;
case 44:
#line 641 "config_grammar.y"
{
		    set_current_globals();
		    tmp_config->globals->destination = DEST_AUTO;
                      }
break;
case 45:
#line 645 "config_grammar.y"
{
		    set_current_globals();
		    tmp_config->globals->destination = DEST_BSSID;
                      }
break;
case 46:
#line 649 "config_grammar.y"
{
		    set_current_globals();
		    tmp_config->globals->destination = DEST_MULTICAST;
                      }
break;
case 47:
#line 653 "config_grammar.y"
{
		    set_current_globals();
		    tmp_config->globals->destination = DEST_SOURCE;
                      }
break;
case 48:
#line 657 "config_grammar.y"
{
		    printf("Invalid destination value = \"%s\"!  Defaulting to AUTO! (Line : %d)\n", yyvsp[0].str, config_linenum);
                    set_current_globals();
                    tmp_config->globals->destination = DEST_AUTO;
                      }
break;
case 49:
#line 662 "config_grammar.y"
{
                    set_current_globals();
                    if (!tmp_config->globals->log_facility)
                          tmp_config->globals->log_facility = yyvsp[0].str;
                    else
                      free(yyvsp[0].str);
                    }
break;
case 50:
#line 671 "config_grammar.y"
{
                       parameter_debug("network_list: \"%s\"\n", yyvsp[0].str);
		       set_current_globals();
		       if (config_string_list_contains_string(tmp_config->globals->allowed_nets,
							    yyvsp[0].str))
			 free(yyvsp[0].str);
		       else 
			 config_string_list_add_string(&tmp_config->globals->allowed_nets,
						     yyvsp[0].str);
                    }
break;
case 51:
#line 681 "config_grammar.y"
{ 
                       parameter_debug("network_list: \"%s\"\n", yyvsp[0].str);
		       set_current_globals();
		       if (config_string_list_contains_string(tmp_config->globals->allowed_nets,
							    yyvsp[0].str))
			 free(yyvsp[0].str);
		       else 
			 config_string_list_add_string(&tmp_config->globals->allowed_nets,
						     yyvsp[0].str);
                    }
break;
case 52:
#line 691 "config_grammar.y"
{
                       parameter_debug("network_list: \"%s\"\n", yyvsp[0].str);
		       set_current_globals();
		       if (config_string_list_contains_string(tmp_config->globals->allowed_nets,
							    yyvsp[0].str))
			 free(yyvsp[0].str);
		       else 
			 config_string_list_add_string(&tmp_config->globals->allowed_nets,
						     yyvsp[0].str);
                    }
break;
case 53:
#line 701 "config_grammar.y"
{ 
                       parameter_debug("network_list: \"%s\"\n", yyvsp[0].str);
		       set_current_globals();
		       if (config_string_list_contains_string(tmp_config->globals->allowed_nets,
							    yyvsp[0].str))
			 free(yyvsp[0].str);
		       else 
			 config_string_list_add_string(&tmp_config->globals->allowed_nets,
						     yyvsp[0].str);
                    }
break;
case 54:
#line 713 "config_grammar.y"
{
                      set_current_config();
		      tmp_network->name = yyvsp[-3].str;

		      /* check if there is a networks field and that */
		      /* the current tmp is not already listed*/
		      if ((!tmp_config->networks ||
			  !config_network_contains_net(tmp_config->networks,
						       tmp_network->name)) &&
			  config_allows_network(tmp_config, tmp_network->name))
		      {
			config_network_add_net(&(tmp_config->networks),
					       tmp_network);
		      }
		      /* if we don't need it, delete it*/
		      else {
			delete_config_network(&tmp_network);
		      }
		      tmp_network = NULL;
                    }
break;
case 55:
#line 733 "config_grammar.y"
{
                      set_current_config();

		      tmp_network->name = (char *)malloc(100);
		      sprintf(tmp_network->name, "%d", yyvsp[-3].num);

		      /* check if there is a networks field and that */
		      /* the current tmp is not already listed*/
		      if ((!tmp_config->networks ||
			  !config_network_contains_net(tmp_config->networks,
						       tmp_network->name)) &&
			  config_allows_network(tmp_config, tmp_network->name))
		      {
			config_network_add_net(&(tmp_config->networks),
					       tmp_network);
		      }
		      /* if we don't need it, delete it*/
		      else {
			delete_config_network(&tmp_network);
		      }
		      tmp_network = NULL;
                    }
break;
case 56:
#line 755 "config_grammar.y"
{
		    set_current_config();
		    tmp_network->name = yyvsp[-3].str;

		      /* check if there is a networks field and that */
		      /* the current tmp is not already listed*/
		      if ((!tmp_config->networks ||
			  !config_network_contains_net(tmp_config->networks,
						       tmp_network->name)) &&
			  config_allows_network(tmp_config, tmp_network->name))
		      {
			config_network_add_net(&(tmp_config->networks),
					       tmp_network);
		      }
		      /* if we don't need it, delete it*/
		      else {
			delete_config_network(&tmp_network);
		      }
		      tmp_network = NULL;
		    }
break;
case 57:
#line 775 "config_grammar.y"
{
		    set_current_config();
		      set_current_network();

		      tmp_network->name = yyvsp[-2].str;
		      /* check if there is a networks field and that */
		      /* the current tmp is not already listed*/
		      if ((!tmp_config->networks ||
			  !config_network_contains_net(tmp_config->networks,
						       tmp_network->name)) &&
			  config_allows_network(tmp_config, tmp_network->name))
		      {
			config_network_add_net(&(tmp_config->networks),
					       tmp_network);
		      }
		      /* if we don't need it, delete it*/
		      else {
			delete_config_network(&tmp_network);
		      }
		      tmp_network = NULL;
                    }
break;
case 58:
#line 796 "config_grammar.y"
{
                      set_current_config();
		      set_current_network();

		      tmp_network->name = yyvsp[-2].str;
		      /* check if there is a networks field and that */
		      /* the current tmp is not already listed*/
		      if ((!tmp_config->networks ||
			  !config_network_contains_net(tmp_config->networks,
						       tmp_network->name)) &&
			  config_allows_network(tmp_config, tmp_network->name))
		      {
			config_network_add_net(&(tmp_config->networks),
					       tmp_network);
		      }
		      /* if we don't need it, delete it*/
		      else {
			delete_config_network(&tmp_network);
		      }
		      tmp_network = NULL;
		    }
break;
case 59:
#line 817 "config_grammar.y"
{
                      set_current_config();
		      set_current_network();

		      tmp_network->name = (char *)malloc(100);
		      sprintf(tmp_network->name, "%d", yyvsp[-2].num);
		      /* check if there is a networks field and that */
		      /* the current tmp is not already listed*/
		      if ((!tmp_config->networks ||
			  !config_network_contains_net(tmp_config->networks,
						       tmp_network->name)) &&
			  config_allows_network(tmp_config, tmp_network->name))
		      {
			config_network_add_net(&(tmp_config->networks),
					       tmp_network);
		      }
		      /* if we don't need it, delete it*/
		      else {
			delete_config_network(&tmp_network);
		      }
		      tmp_network = NULL;
		    }
break;
case 75:
#line 861 "config_grammar.y"
{
                           parameter_debug("Priority : %d\n", yyvsp[0].num);
                           set_current_network();
                           tmp_network->priority = yyvsp[0].num;
                         }
break;
case 76:
#line 868 "config_grammar.y"
{
                           parameter_debug("Type: Wireless\n");
			   set_current_network();
			   if (tmp_network->type == UNSET)
			     tmp_network->type = WIRELESS;
                         }
break;
case 77:
#line 874 "config_grammar.y"
{
                           parameter_debug("Type: Wired\n");
			   set_current_network();
			   if (tmp_network->type == UNSET)
			     tmp_network->type = WIRED;
                         }
break;
case 78:
#line 880 "config_grammar.y"
{
			   set_current_network();
			   tmp_network->type = UNSET;
			   printf("Unknown interface type = \"%s\"!  Defaulting to UNSET! (Line : %d)\n", yyvsp[0].str, config_linenum);
			 }
break;
case 79:
#line 887 "config_grammar.y"
{
                              parameter_debug("WPA Group Crypt : WEP40\n");
			      set_current_network();
			      tmp_network->wpa_group_crypt = CRYPT_WEP40;
			      }
break;
case 80:
#line 892 "config_grammar.y"
{
			      parameter_debug("WPA Group Crypt : TKIP\n");
			      set_current_network();
			      tmp_network->wpa_group_crypt = CRYPT_TKIP;
			      }
break;
case 81:
#line 897 "config_grammar.y"
{
			      parameter_debug("WPA Group Crypt : WRAP\n");
			      set_current_network();
			      tmp_network->wpa_group_crypt = CRYPT_WRAP;
			      }
break;
case 82:
#line 902 "config_grammar.y"
{
			      parameter_debug("WPA Group Crypt : CCMP\n");
			      set_current_network();
			      tmp_network->wpa_group_crypt = CRYPT_CCMP;
			      }
break;
case 83:
#line 907 "config_grammar.y"
{
			      parameter_debug("WPA Group Crypt : WEP104\n");
			      set_current_network();
			      tmp_network->wpa_group_crypt = CRYPT_WEP104;
			      }
break;
case 84:
#line 914 "config_grammar.y"
{
                                 parameter_debug("WPA Pairwise Crypt : WEP40\n");
				 set_current_network();
				 tmp_network->wpa_pairwise_crypt = CRYPT_WEP40;
                                 }
break;
case 85:
#line 919 "config_grammar.y"
{
				 parameter_debug("WPA Pairwise Crypt : TKIP\n");
				 set_current_network();
				 tmp_network->wpa_pairwise_crypt = CRYPT_TKIP;
			         }
break;
case 86:
#line 924 "config_grammar.y"
{
				 parameter_debug("WPA Pairwise Crypt : WRAP\n");
				 set_current_network();
				 tmp_network->wpa_pairwise_crypt = CRYPT_WRAP;
	      		         }
break;
case 87:
#line 929 "config_grammar.y"
{
				 parameter_debug("WPA Pairwise Crypt : CCMP\n");
				 set_current_network();
				 tmp_network->wpa_pairwise_crypt = CRYPT_CCMP;
			         }
break;
case 88:
#line 934 "config_grammar.y"
{
				 parameter_debug("WPA Pairwise Crypt : WEP104\n");
				 set_current_network();
				 tmp_network->wpa_pairwise_crypt = CRYPT_WEP104;
			         }
break;
case 89:
#line 941 "config_grammar.y"
{
                           parameter_debug("Force EAPOL Version : %d\n", yyvsp[0].num);
                           set_current_network();
                           tmp_network->force_eapol_ver = yyvsp[0].num;
                         }
break;
case 90:
#line 948 "config_grammar.y"
{
                           parameter_debug("Association Type : Open\n");
			   set_current_network();
			   tmp_network->assoc_type = ASSOC_OPEN;
                        }
break;
case 91:
#line 953 "config_grammar.y"
{
			   parameter_debug("Association Type : Shared\n");
			   set_current_network();
			   tmp_network->assoc_type = ASSOC_SHARED;
			 }
break;
case 92:
#line 958 "config_grammar.y"
{
			  parameter_debug("Association Type : LEAP\n");
			  set_current_network();
			  tmp_network->assoc_type = ASSOC_LEAP;
			}
break;
case 93:
#line 965 "config_grammar.y"
{
                           parameter_debug("Control Wireless = YES\n");
			   set_current_network();
			   if (tmp_network->wireless_ctrl == CTL_UNSET)
			     tmp_network->wireless_ctrl = CTL_YES;
                         }
break;
case 94:
#line 971 "config_grammar.y"
{
			   parameter_debug("Control Wireless = NO\n");
			   set_current_network();
			   if (tmp_network->wireless_ctrl == CTL_UNSET)
			     tmp_network->wireless_ctrl = CTL_NO;
			 }
break;
case 95:
#line 977 "config_grammar.y"
{
			   set_current_network();
			   tmp_network->wireless_ctrl = CTL_UNSET;
			   printf("Unknown option for Control Wireless = \"%s\"!  Defaulting to UNSET! (Line : %d)\n", yyvsp[0].str, config_linenum);
			 }
break;
case 96:
#line 984 "config_grammar.y"
{
                            parameter_debug("ID: \"%s\"\n", yyvsp[0].str);
			    set_current_network();
			    if (!tmp_network->identity)
			      tmp_network->identity = yyvsp[0].str;
			    else
			      free(yyvsp[0].str);
                          }
break;
case 97:
#line 992 "config_grammar.y"
{
			    parameter_debug("ID: \"%s\"\n", yyvsp[0].str);
			    set_current_network();
			    if (!tmp_network->identity)
			      tmp_network->identity = yyvsp[0].str;
			    else
			      free(yyvsp[0].str);
			  }
break;
case 98:
#line 1000 "config_grammar.y"
{
			    parameter_debug("ID: \"%s\"\n", yyvsp[0].str);
			    set_current_network();
			    if (!tmp_network->identity)
			      tmp_network->identity = yyvsp[0].str;
			    else
			      free(yyvsp[0].str);
			  }
break;
case 99:
#line 1010 "config_grammar.y"
{
                          parameter_debug("Use TNC : Yes");
                          set_current_network();
                          SET_FLAG(tmp_network->flags, CONFIG_NET_USE_TNC);
                        }
break;
case 100:
#line 1015 "config_grammar.y"
{
                          parameter_debug("Use TNC : No");
                          set_current_network();
                          UNSET_FLAG(tmp_network->flags, CONFIG_NET_USE_TNC);
                        }
break;
case 101:
#line 1022 "config_grammar.y"
{
                            parameter_debug("Dest Mac: %s\n", yyvsp[0].str);
			    set_current_network();
			    if (TEST_FLAG(tmp_network->flags, CONFIG_NET_DEST_MAC)) {
			      free(yyvsp[0].str);
			    }
			    else {
			      int tmp_dst_mac[CONFIG_MAC_LEN];
			      int retval;
			      SET_FLAG(tmp_network->flags, CONFIG_NET_DEST_MAC);
			      retval = sscanf(yyvsp[0].str, "%2x:%2x:%2x:%2x:%2x:%2x", 
				     &tmp_dst_mac[0], 
				     &tmp_dst_mac[1], 
				     &tmp_dst_mac[2], 
				     &tmp_dst_mac[3], 
				     &tmp_dst_mac[4], 
				     &tmp_dst_mac[5]);
			      tmp_network->dest_mac[0] = tmp_dst_mac[0];
			      tmp_network->dest_mac[1] = tmp_dst_mac[1];
			      tmp_network->dest_mac[2] = tmp_dst_mac[2];
			      tmp_network->dest_mac[3] = tmp_dst_mac[3];
			      tmp_network->dest_mac[4] = tmp_dst_mac[4];
			      tmp_network->dest_mac[5] = tmp_dst_mac[5];
			    }
                         }
break;
case 102:
#line 1049 "config_grammar.y"
{
                           parameter_debug("Allow Types: ALL\n");
			   set_current_network();
			   SET_FLAG(tmp_network->flags, CONFIG_NET_ALLOW_ALL);
                       }
break;
case 104:
#line 1057 "config_grammar.y"
{
                       set_current_network(); 
		       if (!config_eap_method_contains_method(tmp_network->methods,
							      EAP_TYPE_TLS)) {
			 add_config_eap_method(&(tmp_network->methods),
					       EAP_TYPE_TLS,
					       tmp_tls);
		       }
		       else 
			 delete_config_eap_tls(&tmp_tls);
		       tmp_tls = NULL;
                      }
break;
case 105:
#line 1069 "config_grammar.y"
{
                       set_current_network(); 
		       if (!config_eap_method_contains_method(tmp_network->methods,
							      EAP_TYPE_MD5))
			 add_config_eap_method(&(tmp_network->methods),
					       EAP_TYPE_MD5,
					       tmp_md5);
		       else 
			 delete_config_eap_md5(&tmp_md5);
		       tmp_md5 = NULL;
                      }
break;
case 106:
#line 1080 "config_grammar.y"
{
                       set_current_network(); 
		       if (!config_eap_method_contains_method(tmp_network->methods,
							      EAP_TYPE_TTLS))
			 add_config_eap_method(&(tmp_network->methods),
					       EAP_TYPE_TTLS,
					       tmp_ttls);
		       else 
			 delete_config_eap_ttls(&tmp_ttls);
		       tmp_ttls = NULL;
                      }
break;
case 107:
#line 1091 "config_grammar.y"
{
		      set_current_network();
		      if (!config_eap_method_contains_method(tmp_network->methods,
							     STATIC_WEP_METHOD))
			add_config_eap_method(&(tmp_network->methods),
					      STATIC_WEP_METHOD,
					      tmp_static_wep);
		      }
break;
case 108:
#line 1099 "config_grammar.y"
{
		      set_current_network();
                      tmp_network->initial_wep = tmp_initial_wep;
		    }
break;
case 109:
#line 1103 "config_grammar.y"
{
                       set_current_network(); 
		       if (!config_eap_method_contains_method(tmp_network->methods,
							      EAP_TYPE_LEAP))
			 add_config_eap_method(&(tmp_network->methods),
					       EAP_TYPE_LEAP,
					       tmp_leap);
		       else 
			 delete_config_eap_leap(&tmp_leap);
		       tmp_leap = NULL;
                      }
break;
case 110:
#line 1114 "config_grammar.y"
{
                       set_current_network(); 
		       if (!config_eap_method_contains_method(tmp_network->methods,
							      EAP_TYPE_MSCHAPV2))
			 add_config_eap_method(&(tmp_network->methods),
					       EAP_TYPE_MSCHAPV2,
					       tmp_mschapv2);
		       else 
			 delete_config_eap_mschapv2(&tmp_mschapv2);
		       tmp_mschapv2 = NULL;
                      }
break;
case 111:
#line 1125 "config_grammar.y"
{
                       set_current_network(); 
		       if (!config_eap_method_contains_method(tmp_network->methods,
							      EAP_TYPE_PEAP))
			 add_config_eap_method(&(tmp_network->methods),
					       EAP_TYPE_PEAP,
					       tmp_peap);
		       else 
			 delete_config_eap_peap(&tmp_peap);
		       tmp_peap = NULL;
                      }
break;
case 112:
#line 1136 "config_grammar.y"
{
                       set_current_network(); 
		       if (!config_eap_method_contains_method(tmp_network->methods,
							      EAP_TYPE_SIM))
			 add_config_eap_method(&(tmp_network->methods),
					       EAP_TYPE_SIM,
					       tmp_sim);
		       else 
			 delete_config_eap_sim(&tmp_sim);
		       tmp_sim = NULL;
                      }
break;
case 113:
#line 1147 "config_grammar.y"
{
		      set_current_network();
		      if (!config_eap_method_contains_method(tmp_network->methods,
							     EAP_TYPE_AKA))
			add_config_eap_method(&(tmp_network->methods),
					      EAP_TYPE_AKA,
					      tmp_aka);
		      else
			delete_config_eap_aka(&tmp_aka);
		      tmp_aka = NULL;
                      }
break;
case 114:
#line 1158 "config_grammar.y"
{
		      set_current_network();
		      if (!config_eap_method_contains_method(tmp_network->methods,
							     WPA_PSK))
			add_config_eap_method(&(tmp_network->methods),
					      WPA_PSK,
					      tmp_wpa_psk);
		      else
			delete_config_wpa_psk(&tmp_wpa_psk);
		      tmp_wpa_psk = NULL;
                      }
break;
case 117:
#line 1175 "config_grammar.y"
{
                        parameter_debug("Allow Type: TLS\n");
			set_current_network();
			SET_FLAG(tmp_network->flags, CONFIG_NET_ALLOW_TLS);
                      }
break;
case 118:
#line 1180 "config_grammar.y"
{
                        parameter_debug("Allow Type: MD5\n");
			set_current_network();
			SET_FLAG(tmp_network->flags, CONFIG_NET_ALLOW_MD5);
                      }
break;
case 119:
#line 1185 "config_grammar.y"
{
                        parameter_debug("Allow Type: TTLS\n");
			set_current_network();
			SET_FLAG(tmp_network->flags, CONFIG_NET_ALLOW_TTLS);
                      }
break;
case 120:
#line 1190 "config_grammar.y"
{
                        parameter_debug("Allow Type: LEAP\n");
			set_current_network();
			SET_FLAG(tmp_network->flags, CONFIG_NET_ALLOW_LEAP);
                      }
break;
case 121:
#line 1195 "config_grammar.y"
{
                        parameter_debug("Allow Type: MSCHAPV2\n");
			set_current_network();
			SET_FLAG(tmp_network->flags, CONFIG_NET_ALLOW_MSCV2);
                      }
break;
case 122:
#line 1200 "config_grammar.y"
{
                        parameter_debug("Allow Type: PEAP\n");
			set_current_network();
			SET_FLAG(tmp_network->flags, CONFIG_NET_ALLOW_PEAP);
                      }
break;
case 123:
#line 1205 "config_grammar.y"
{
                        parameter_debug("Allow Type: SIM\n");
			set_current_network();
			SET_FLAG(tmp_network->flags, CONFIG_NET_ALLOW_SIM);
                      }
break;
case 124:
#line 1210 "config_grammar.y"
{
		        parameter_debug("Allow Type: AKA\n");
		        set_current_network();
		        SET_FLAG(tmp_network->flags, CONFIG_NET_ALLOW_AKA);
		      }
break;
case 125:
#line 1215 "config_grammar.y"
{
                        parameter_debug("Allow Type: GTC\n");
			set_current_network();
			SET_FLAG(tmp_network->flags, CONFIG_NET_ALLOW_GTC);
                      }
break;
case 126:
#line 1220 "config_grammar.y"
{
                        parameter_debug("Allow Type: OTP\n");
			set_current_network();
			SET_FLAG(tmp_network->flags, CONFIG_NET_ALLOW_OTP);
                      }
break;
case 128:
#line 1228 "config_grammar.y"
{
                        set_current_static_wep();  
                      }
break;
case 131:
#line 1237 "config_grammar.y"
{
                        set_current_static_wep();
                        parameter_debug("Static Key 1 : %s\n", yyvsp[0].str);
			if (!tmp_static_wep->key[1])
			  tmp_static_wep->key[1] = (uint8_t *) yyvsp[0].str;
                      }
break;
case 132:
#line 1243 "config_grammar.y"
{
		        set_current_static_wep();
		        parameter_debug("Static Key 2 : %s\n", yyvsp[0].str);
		        if (!tmp_static_wep->key[2])
			  tmp_static_wep->key[2] = (uint8_t *) yyvsp[0].str;
		    }
break;
case 133:
#line 1249 "config_grammar.y"
{
		        set_current_static_wep();
                        parameter_debug("Static Key 3 : %s\n", yyvsp[0].str);
                        if (!tmp_static_wep->key[3])
                          tmp_static_wep->key[3] = (uint8_t *) yyvsp[0].str;
                    }
break;
case 134:
#line 1255 "config_grammar.y"
{
		        set_current_static_wep();
                        parameter_debug("Static Key 4 : %s\n", yyvsp[0].str);
                        if (!tmp_static_wep->key[4])
                          tmp_static_wep->key[4] = (uint8_t *) yyvsp[0].str;
                    }
break;
case 135:
#line 1261 "config_grammar.y"
{
                        set_current_static_wep();
                        parameter_debug("TX Key : %d\n", yyvsp[0].num);
			if ((yyvsp[0].num>4) || (yyvsp[0].num<1))
			  {
			    printf("Static WEP key index is out of range!  It must be a number in the range 1..4!  Defaulting to 1.\n");
			    tmp_static_wep->tx_key = 1;
			  } else {
			    tmp_static_wep->tx_key = yyvsp[0].num;
			  }
                    }
break;
case 137:
#line 1275 "config_grammar.y"
{
                        set_current_initial_wep();
                      }
break;
case 140:
#line 1284 "config_grammar.y"
{
                        set_current_initial_wep();
                        parameter_debug("Initial Key 1 : %s\n", yyvsp[0].str);
			if (!tmp_initial_wep->key[1])
			  tmp_initial_wep->key[1] = (uint8_t *) yyvsp[0].str;
                    }
break;
case 141:
#line 1290 "config_grammar.y"
{
		        set_current_initial_wep();
		        parameter_debug("Initial Key 2 : %s\n", yyvsp[0].str);
		        if (!tmp_initial_wep->key[2])
			  tmp_initial_wep->key[2] = (uint8_t *) yyvsp[0].str;
		    }
break;
case 142:
#line 1296 "config_grammar.y"
{
		        set_current_initial_wep();
                        parameter_debug("Initial Key 3 : %s\n", yyvsp[0].str);
                        if (!tmp_initial_wep->key[3])
                          tmp_initial_wep->key[3] = (uint8_t *) yyvsp[0].str;
                    }
break;
case 143:
#line 1302 "config_grammar.y"
{
		        set_current_initial_wep();
                        parameter_debug("Initial Key 4 : %s\n", yyvsp[0].str);
                        if (!tmp_initial_wep->key[4])
                          tmp_initial_wep->key[4] = (uint8_t *) yyvsp[0].str;
                    }
break;
case 144:
#line 1308 "config_grammar.y"
{
                        set_current_initial_wep();
                        parameter_debug("Initial TX Key : %d\n", yyvsp[0].num);
			if ((yyvsp[0].num>4) || (yyvsp[0].num<1))
			  {
			    printf("Initial WEP key index is out of range!  It must be a number in the range 1..4!  Defaulting to 1.\n");
			    tmp_initial_wep->tx_key = 1;
			  } else {
			    tmp_initial_wep->tx_key = yyvsp[0].num;
                     }
                    }
break;
case 146:
#line 1323 "config_grammar.y"
{
                        set_current_tls(); /* define an empty tls struct*/
                      }
break;
case 149:
#line 1332 "config_grammar.y"
{
		    	set_current_tls();
			parameter_debug("Using Engine: \"%s\"\n", 
						tmp_tls->sc.engine_id);
		      }
break;
case 152:
#line 1344 "config_grammar.y"
{
                        set_current_tls();
			tmp_tls->sc.engine_id = strdup(yyvsp[0].str);
		        parameter_debug("engine: \"%s\"\n", 
						tmp_tls->sc.engine_id);
		      }
break;
case 153:
#line 1350 "config_grammar.y"
{
                        set_current_tls();
			tmp_tls->sc.opensc_so_path = yyvsp[0].str;
                        parameter_debug("opensc_so_path: \"%s\"\n", 
						tmp_tls->sc.opensc_so_path);
                      }
break;
case 154:
#line 1356 "config_grammar.y"
{
		        set_current_tls();
			tmp_tls->sc.opensc_so_path = yyvsp[0].str;
			parameter_debug("opensc_so_path: \"%s\"\n",
					tmp_tls->sc.opensc_so_path);
		    }
break;
case 155:
#line 1362 "config_grammar.y"
{
                        set_current_tls();
			tmp_tls->sc.key_id = yyvsp[0].str;
                        parameter_debug("cert_id: \"%s\"\n", 
						tmp_tls->sc.key_id);
                      }
break;
case 156:
#line 1368 "config_grammar.y"
{
                        set_current_tls();
			tmp_tls->sc.key_id = (char *)malloc(5);
			sprintf(tmp_tls->sc.key_id, "%d", yyvsp[0].num);
                        parameter_debug("cert_id: \"%s\"\n", 
						tmp_tls->sc.key_id);
                      }
break;
case 157:
#line 1377 "config_grammar.y"
{
                        parameter_debug("tls user cert: \"%s\"\n", yyvsp[0].str);
			set_current_tls();
			if (!tmp_tls->user_cert)
			  tmp_tls->user_cert = yyvsp[0].str;
			else
			  free(yyvsp[0].str);
                      }
break;
case 158:
#line 1385 "config_grammar.y"
{
  		        parameter_debug("tls user cert: \"%s\"\n", yyvsp[0].str);
			set_current_tls();
			if (!tmp_tls->user_cert)
			  tmp_tls->user_cert = yyvsp[0].str;
			else
			  free(yyvsp[0].str);
		      }
break;
case 159:
#line 1393 "config_grammar.y"
{
	 	        parameter_debug("tls user key: \"%s\"\n", yyvsp[0].str);
			set_current_tls();
			if (!tmp_tls->user_key)
			  tmp_tls->user_key = yyvsp[0].str;
			else 
			  free(yyvsp[0].str);
        	      }
break;
case 160:
#line 1401 "config_grammar.y"
{
 		        parameter_debug("tls user key: \"%s\"\n", yyvsp[0].str);
			set_current_tls();
			if (!tmp_tls->user_key)
			  tmp_tls->user_key = yyvsp[0].str;
			else
			  free(yyvsp[0].str);
		      }
break;
case 161:
#line 1409 "config_grammar.y"
{
	 	        parameter_debug("tls user pass: \"%s\"\n", yyvsp[0].str);
			set_current_tls();
			if (!tmp_tls->user_key_pass)
			  tmp_tls->user_key_pass = yyvsp[0].str;
			else
			  free(yyvsp[0].str);
        	      }
break;
case 162:
#line 1417 "config_grammar.y"
{
		        parameter_debug("tls user pass: \"%s\"\n", yyvsp[0].str);
			set_current_tls();
			if (!tmp_tls->user_key_pass)
			  tmp_tls->user_key_pass = yyvsp[0].str;
			else
			  free(yyvsp[0].str);
		      }
break;
case 163:
#line 1425 "config_grammar.y"
{
		        parameter_debug("tls user pass: \"%s\"\n", yyvsp[0].str);
			set_current_tls();
			if (!tmp_tls->user_key_pass)
			  tmp_tls->user_key_pass = yyvsp[0].str;
			else
			  free(yyvsp[0].str);
		      }
break;
case 164:
#line 1433 "config_grammar.y"
{
		        parameter_debug("Session Resumption = YES\n");
		        set_current_tls();
		        if (tmp_tls->session_resume == RES_UNSET)
			  tmp_tls->session_resume = RES_YES;
		      }
break;
case 165:
#line 1439 "config_grammar.y"
{
			parameter_debug("Session Resumption = NO\n");
			set_current_tls();
			if (tmp_tls->session_resume == RES_UNSET)
			  tmp_tls->session_resume = RES_NO;
		      }
break;
case 166:
#line 1445 "config_grammar.y"
{
		      set_current_tls();
		      tmp_tls->session_resume = RES_NO;
		      printf("Invalid value for session resumption = \"%s\"!  Defaulting to NO! (Line : %d)\n", yyvsp[0].str, config_linenum);
		    }
break;
case 167:
#line 1450 "config_grammar.y"
{
	 	        parameter_debug("tls root_cert: \"%s\"\n", yyvsp[0].str);
			set_current_tls();
			if (!tmp_tls->root_cert)
			  tmp_tls->root_cert = yyvsp[0].str;
			else
			  free(yyvsp[0].str);
        	      }
break;
case 168:
#line 1458 "config_grammar.y"
{
		        parameter_debug("tls root_cert: \"%s\"\n", yyvsp[0].str);
			set_current_tls();
			if (!tmp_tls->root_cert)
			  tmp_tls->root_cert = yyvsp[0].str;
			else
			  free(yyvsp[0].str);
		      }
break;
case 169:
#line 1466 "config_grammar.y"
{
	 	        parameter_debug("tls root_dir: \"%s\"\n", yyvsp[0].str);
			set_current_tls();
			if (!tmp_tls->root_dir)
			  tmp_tls->root_dir = yyvsp[0].str;
			else
			  free(yyvsp[0].str);
        	      }
break;
case 170:
#line 1474 "config_grammar.y"
{
		        parameter_debug("tls root_dir: \"%s\"\n", yyvsp[0].str);
			set_current_tls();
			if (!tmp_tls->root_dir)
			  tmp_tls->root_dir = yyvsp[0].str;
			else
			  free(yyvsp[0].str);
		      }
break;
case 171:
#line 1482 "config_grammar.y"
{
	 	        parameter_debug("tls crl_dir: \"%s\"\n", yyvsp[0].str);
			set_current_tls();
			if (!tmp_tls->crl_dir)
			  tmp_tls->crl_dir = yyvsp[0].str;
			else
			  free(yyvsp[0].str);
        	      }
break;
case 172:
#line 1490 "config_grammar.y"
{
		        parameter_debug("tls crl_dir: \"%s\"\n", yyvsp[0].str);
			set_current_tls();
			if (!tmp_tls->crl_dir)
			  tmp_tls->crl_dir = yyvsp[0].str;
			else
			  free(yyvsp[0].str);
		      }
break;
case 173:
#line 1498 "config_grammar.y"
{
 		        parameter_debug("tls chunk: %d\n", yyvsp[0].num);
			set_current_tls();
			if (tmp_tls->chunk_size == 0)
			  tmp_tls->chunk_size = yyvsp[0].num;
  		      }
break;
case 174:
#line 1504 "config_grammar.y"
{
	 	        parameter_debug("tls rand: \"%s\"\n", yyvsp[0].str);
			set_current_tls();
			if (!tmp_tls->random_file)
			  tmp_tls->random_file = yyvsp[0].str;
			else 
			  free(yyvsp[0].str);
        	      }
break;
case 175:
#line 1512 "config_grammar.y"
{
		        parameter_debug("tls rand: \"%s\"\n", yyvsp[0].str);
			set_current_tls();
			if (!tmp_tls->random_file)
			  tmp_tls->random_file = yyvsp[0].str;
			else
			  free(yyvsp[0].str);
		    }
break;
case 178:
#line 1524 "config_grammar.y"
{
                        set_current_md5(); /* define an empty md5 struct*/
                      }
break;
case 181:
#line 1533 "config_grammar.y"
{
                       parameter_debug("md5 username: \"%s\"\n", yyvsp[0].str);
		       set_current_md5();
		       if (!tmp_md5->username)
			 tmp_md5->username = yyvsp[0].str;
		       else
			 free(yyvsp[0].str);
                     }
break;
case 182:
#line 1541 "config_grammar.y"
{
		       parameter_debug("md5 username: \"%s\"\n", yyvsp[0].str);
		       set_current_md5();
		       if (!tmp_md5->username)
			 tmp_md5->username = yyvsp[0].str;
		       else
			 free(yyvsp[0].str);
		     }
break;
case 183:
#line 1549 "config_grammar.y"
{
		       parameter_debug("md5 username: \"%s\"\n", yyvsp[0].str);
		       set_current_md5();
		       if (!tmp_md5->username)
			 tmp_md5->username = yyvsp[0].str;
		       else
			 free(yyvsp[0].str);
		     }
break;
case 184:
#line 1557 "config_grammar.y"
{
		       parameter_debug("md5 password: \"%s\"\n", yyvsp[0].str);
		       set_current_md5();
		       if (!tmp_md5->password)
			 tmp_md5->password = yyvsp[0].str;
		       else
			 free(yyvsp[0].str);
		     }
break;
case 185:
#line 1565 "config_grammar.y"
{
		       parameter_debug("md5 password: \"%s\"\n", yyvsp[0].str);
		       set_current_md5();
		       if (!tmp_md5->password)
			 tmp_md5->password = yyvsp[0].str;
		       else
			 free(yyvsp[0].str);
		     }
break;
case 186:
#line 1573 "config_grammar.y"
{
		       parameter_debug("md5 password: \"%s\"\n", yyvsp[0].str);
		       set_current_md5();
		       if (!tmp_md5->password)
			 tmp_md5->password = yyvsp[0].str;
		       else
			 free(yyvsp[0].str);
		     }
break;
case 188:
#line 1584 "config_grammar.y"
{
                        set_current_ttls(); /* define an empty ttls struct*/
                      }
break;
case 191:
#line 1593 "config_grammar.y"
{
                        parameter_debug("ttls user cert: \"%s\"\n", yyvsp[0].str);
			set_current_ttls();
			if (!tmp_ttls->user_cert)
			  tmp_ttls->user_cert = yyvsp[0].str;
			else
			  free(yyvsp[0].str);
                      }
break;
case 192:
#line 1601 "config_grammar.y"
{
		        parameter_debug("ttls user cert: \"%s\"\n", yyvsp[0].str);
			set_current_ttls();
			if (!tmp_ttls->user_cert)
			  tmp_ttls->user_cert = yyvsp[0].str;
			else
			  free(yyvsp[0].str);
		      }
break;
case 193:
#line 1609 "config_grammar.y"
{
	 	        parameter_debug("ttls user key: \"%s\"\n", yyvsp[0].str);
			set_current_ttls();
			if (!tmp_ttls->user_key)
			  tmp_ttls->user_key = yyvsp[0].str;
			else 
			  free(yyvsp[0].str);
        	      }
break;
case 194:
#line 1617 "config_grammar.y"
{
	 	        parameter_debug("ttls user key: \"%s\"\n", yyvsp[0].str);
			set_current_ttls();
			if (!tmp_ttls->user_key)
			  tmp_ttls->user_key = yyvsp[0].str;
			else 
			  free(yyvsp[0].str);
        	      }
break;
case 195:
#line 1625 "config_grammar.y"
{
	 	        parameter_debug("ttls user pass: \"%s\"\n", yyvsp[0].str);
			set_current_ttls();
			if (!tmp_ttls->user_key_pass)
			  tmp_ttls->user_key_pass = yyvsp[0].str;
			else
			  free(yyvsp[0].str);
        	      }
break;
case 196:
#line 1633 "config_grammar.y"
{
	 	        parameter_debug("ttls user pass: \"%s\"\n", yyvsp[0].str);
			set_current_ttls();
			if (!tmp_ttls->user_key_pass)
			  tmp_ttls->user_key_pass = yyvsp[0].str;
			else
			  free(yyvsp[0].str);
        	      }
break;
case 197:
#line 1641 "config_grammar.y"
{
	 	        parameter_debug("ttls user pass: \"%s\"\n", yyvsp[0].str);
			set_current_ttls();
			if (!tmp_ttls->user_key_pass)
			  tmp_ttls->user_key_pass = yyvsp[0].str;
			else
			  free(yyvsp[0].str);
        	      }
break;
case 198:
#line 1649 "config_grammar.y"
{
	 	        parameter_debug("ttls root_cert: \"%s\"\n", yyvsp[0].str);
			set_current_ttls();
			if (!tmp_ttls->root_cert)
			  tmp_ttls->root_cert = yyvsp[0].str;
			else
			  free(yyvsp[0].str);
        	      }
break;
case 199:
#line 1657 "config_grammar.y"
{
	 	        parameter_debug("ttls root_cert: \"%s\"\n", yyvsp[0].str);
			set_current_ttls();
			if (!tmp_ttls->root_cert)
			  tmp_ttls->root_cert = yyvsp[0].str;
			else
			  free(yyvsp[0].str);
        	      }
break;
case 200:
#line 1665 "config_grammar.y"
{
	 	        parameter_debug("ttls root_dir: \"%s\"\n", yyvsp[0].str);
			set_current_ttls();
			if (!tmp_ttls->root_dir)
			  tmp_ttls->root_dir = yyvsp[0].str;
			else 
			  free(yyvsp[0].str);
        	      }
break;
case 201:
#line 1673 "config_grammar.y"
{
	 	        parameter_debug("ttls root_dir: \"%s\"\n", yyvsp[0].str);
			set_current_ttls();
			if (!tmp_ttls->root_dir)
			  tmp_ttls->root_dir = yyvsp[0].str;
			else 
			  free(yyvsp[0].str);
        	      }
break;
case 202:
#line 1681 "config_grammar.y"
{
	 	        parameter_debug("ttls crl_dir: \"%s\"\n", yyvsp[0].str);
			set_current_ttls();
			if (!tmp_ttls->crl_dir)
			  tmp_ttls->crl_dir = yyvsp[0].str;
			else 
			  free(yyvsp[0].str);
        	      }
break;
case 203:
#line 1689 "config_grammar.y"
{
	 	        parameter_debug("ttls crl_dir: \"%s\"\n", yyvsp[0].str);
			set_current_ttls();
			if (!tmp_ttls->crl_dir)
			  tmp_ttls->crl_dir = yyvsp[0].str;
			else 
			  free(yyvsp[0].str);
        	      }
break;
case 204:
#line 1697 "config_grammar.y"
{
 		        parameter_debug("ttls chunk: %d\n", yyvsp[0].num);
			set_current_ttls();
			if (tmp_ttls->chunk_size == 0)
			  tmp_ttls->chunk_size = yyvsp[0].num;
  		      }
break;
case 205:
#line 1703 "config_grammar.y"
{
	 	        parameter_debug("ttls rand: \"%s\"\n", yyvsp[0].str);
			set_current_ttls();
			if (!tmp_ttls->random_file)
			  tmp_ttls->random_file = yyvsp[0].str;
			else 
			  free(yyvsp[0].str);
        	      }
break;
case 206:
#line 1711 "config_grammar.y"
{
	 	        parameter_debug("ttls rand: \"%s\"\n", yyvsp[0].str);
			set_current_ttls();
			if (!tmp_ttls->random_file)
			  tmp_ttls->random_file = yyvsp[0].str;
			else 
			  free(yyvsp[0].str);
        	      }
break;
case 207:
#line 1719 "config_grammar.y"
{
		        parameter_debug("Session Resumption = YES\n");
		        set_current_ttls();
		        if (tmp_ttls->session_resume == RES_UNSET)
			  tmp_ttls->session_resume = RES_YES;
		      }
break;
case 208:
#line 1725 "config_grammar.y"
{
			parameter_debug("Session Resumption = NO\n");
			set_current_ttls();
			if (tmp_ttls->session_resume == RES_UNSET)
			  tmp_ttls->session_resume = RES_NO;
		      }
break;
case 209:
#line 1731 "config_grammar.y"
{
		      set_current_ttls();
		      tmp_ttls->session_resume = RES_NO;
		      printf("Invalid value for session resume = \"%s\"!  Defaulting to NO!  (Line : %d)\n", yyvsp[0].str, config_linenum);
		    }
break;
case 210:
#line 1736 "config_grammar.y"
{
		        parameter_debug("ttls CN check : \"%s\"\n", yyvsp[0].str);
                        set_current_ttls();
                        if (!tmp_ttls->cncheck)
                          tmp_ttls->cncheck = yyvsp[0].str;
                        else
                          free(yyvsp[0].str);
		      }
break;
case 211:
#line 1744 "config_grammar.y"
{
  		        parameter_debug("match CN exactly : \"yes\"\n");
		        set_current_ttls();
		        tmp_ttls->cnexact = 1;
		    }
break;
case 212:
#line 1749 "config_grammar.y"
{
  		        parameter_debug("match CN exactly : \"no\"\n");
		        set_current_ttls();
		        tmp_ttls->cnexact = 0;
		    }
break;
case 213:
#line 1754 "config_grammar.y"
{
	 	        parameter_debug("ttls phase2_type 'pap'\n");
			if (tmp_ttls && 
			    tmp_ttls->phase2_type != TTLS_PHASE2_UNDEFINED) {
			  cleanup_parse();
			  return XECONFIGPARSEFAIL;  
			}
			set_current_ttls();
			tmp_ttls->phase2_type = TTLS_PHASE2_PAP;
        	      }
break;
case 214:
#line 1764 "config_grammar.y"
{
	 	        parameter_debug("ttls phase2_type 'chap'\n");
			if (tmp_ttls && 
			    tmp_ttls->phase2_type != TTLS_PHASE2_UNDEFINED) {
			  cleanup_parse();
			  return XECONFIGPARSEFAIL;  
			}
			set_current_ttls();
			tmp_ttls->phase2_type = TTLS_PHASE2_CHAP;
        	      }
break;
case 215:
#line 1774 "config_grammar.y"
{
	 	        parameter_debug("ttls phase2_type 'mschap'\n");
			if (tmp_ttls && 
			    tmp_ttls->phase2_type != TTLS_PHASE2_UNDEFINED) {
			  cleanup_parse();
			  return XECONFIGPARSEFAIL;  
			}
			set_current_ttls();
			tmp_ttls->phase2_type = TTLS_PHASE2_MSCHAP;
        	      }
break;
case 216:
#line 1784 "config_grammar.y"
{
	 	        parameter_debug("ttls phase2_type 'mschapv2'\n");
			if (tmp_ttls && 
			    tmp_ttls->phase2_type != TTLS_PHASE2_UNDEFINED) {
			  cleanup_parse();
			  return XECONFIGPARSEFAIL;  
			}
			set_current_ttls();
			tmp_ttls->phase2_type = TTLS_PHASE2_MSCHAPV2;
        	      }
break;
case 217:
#line 1794 "config_grammar.y"
{
                        parameter_debug("ttls phase2_type 'eap_md5'\n");
                        if (tmp_ttls &&
                            tmp_ttls->phase2_type != TTLS_PHASE2_UNDEFINED) {
                          cleanup_parse();
                          return XECONFIGPARSEFAIL;
                        }
                        set_current_ttls();
                        tmp_ttls->phase2_type = TTLS_PHASE2_EAP_MD5;
                     }
break;
case 224:
#line 1814 "config_grammar.y"
{
                       set_current_ttls(); 
		       if (!config_ttls_phase2_contains_phase2(tmp_ttls->phase2,
							       TTLS_PHASE2_PAP))
			 add_config_ttls_phase2(&(tmp_ttls->phase2), 
						TTLS_PHASE2_PAP,
						tmp_p2pap);
		       else
			 delete_config_pap(&tmp_p2pap);
		       tmp_p2pap = NULL;
                      }
break;
case 227:
#line 1831 "config_grammar.y"
{
                       parameter_debug("pap username: \"%s\"\n", yyvsp[0].str);
		       set_current_p2pap();
		       if (!tmp_p2pap->username)
			 tmp_p2pap->username = yyvsp[0].str;
		       else
			 free(yyvsp[0].str);
                     }
break;
case 228:
#line 1839 "config_grammar.y"
{
                       parameter_debug("pap username: \"%s\"\n", yyvsp[0].str);
		       set_current_p2pap();
		       if (!tmp_p2pap->username)
			 tmp_p2pap->username = yyvsp[0].str;
		       else
			 free(yyvsp[0].str);
                     }
break;
case 229:
#line 1847 "config_grammar.y"
{
                       parameter_debug("pap username: \"%s\"\n", yyvsp[0].str);
		       set_current_p2pap();
		       if (!tmp_p2pap->username)
			 tmp_p2pap->username = yyvsp[0].str;
		       else
			 free(yyvsp[0].str);
                     }
break;
case 230:
#line 1855 "config_grammar.y"
{
		       parameter_debug("pap password: \"%s\"\n", yyvsp[0].str);
		       set_current_p2pap();
		       if (!tmp_p2pap->password)
			 tmp_p2pap->password = yyvsp[0].str;
		       else
			 free(yyvsp[0].str);
		     }
break;
case 231:
#line 1863 "config_grammar.y"
{
		       parameter_debug("pap password: \"%s\"\n", yyvsp[0].str);
		       set_current_p2pap();
		       if (!tmp_p2pap->password)
			 tmp_p2pap->password = yyvsp[0].str;
		       else
			 free(yyvsp[0].str);
		     }
break;
case 232:
#line 1871 "config_grammar.y"
{
		       parameter_debug("pap password: \"%s\"\n", yyvsp[0].str);
		       set_current_p2pap();
		       if (!tmp_p2pap->password)
			 tmp_p2pap->password = yyvsp[0].str;
		       else
			 free(yyvsp[0].str);
		     }
break;
case 233:
#line 1881 "config_grammar.y"
{
                       set_current_ttls(); 
		       if (!config_ttls_phase2_contains_phase2(tmp_ttls->phase2,
							       TTLS_PHASE2_CHAP))
			 add_config_ttls_phase2(&(tmp_ttls->phase2), 
						TTLS_PHASE2_CHAP,
						tmp_p2chap);
		       else
			 delete_config_chap(&tmp_p2chap);
		       tmp_p2chap = NULL;
                      }
break;
case 236:
#line 1898 "config_grammar.y"
{
                       parameter_debug("chap username: \"%s\"\n", yyvsp[0].str);
		       set_current_p2chap();
		       if (!tmp_p2chap->username)
			 tmp_p2chap->username = yyvsp[0].str;
		       else
			 free(yyvsp[0].str);
                     }
break;
case 237:
#line 1906 "config_grammar.y"
{
                       parameter_debug("chap username: \"%s\"\n", yyvsp[0].str);
		       set_current_p2chap();
		       if (!tmp_p2chap->username)
			 tmp_p2chap->username = yyvsp[0].str;
		       else
			 free(yyvsp[0].str);
                     }
break;
case 238:
#line 1914 "config_grammar.y"
{
                       parameter_debug("chap username: \"%s\"\n", yyvsp[0].str);
		       set_current_p2chap();
		       if (!tmp_p2chap->username)
			 tmp_p2chap->username = yyvsp[0].str;
		       else
			 free(yyvsp[0].str);
                     }
break;
case 239:
#line 1922 "config_grammar.y"
{
		       parameter_debug("chap password: \"%s\"\n", yyvsp[0].str);
		       set_current_p2chap();
		       if (!tmp_p2chap->password)
			 tmp_p2chap->password = yyvsp[0].str;
		       else
			 free(yyvsp[0].str);
		     }
break;
case 240:
#line 1930 "config_grammar.y"
{
		       parameter_debug("chap password: \"%s\"\n", yyvsp[0].str);
		       set_current_p2chap();
		       if (!tmp_p2chap->password)
			 tmp_p2chap->password = yyvsp[0].str;
		       else
			 free(yyvsp[0].str);
		     }
break;
case 241:
#line 1938 "config_grammar.y"
{
		       parameter_debug("chap password: \"%s\"\n", yyvsp[0].str);
		       set_current_p2chap();
		       if (!tmp_p2chap->password)
			 tmp_p2chap->password = yyvsp[0].str;
		       else
			 free(yyvsp[0].str);
		     }
break;
case 242:
#line 1948 "config_grammar.y"
{
                       set_current_ttls(); 
		       if (!config_ttls_phase2_contains_phase2(tmp_ttls->phase2,
							       TTLS_PHASE2_MSCHAP))
			 add_config_ttls_phase2(&(tmp_ttls->phase2), 
						TTLS_PHASE2_MSCHAP,
						tmp_p2mschap);
		       else
			 delete_config_mschap(&tmp_p2mschap);
		       tmp_p2mschap = NULL;
                      }
break;
case 245:
#line 1965 "config_grammar.y"
{
                       parameter_debug("mschap username: \"%s\"\n", yyvsp[0].str);
		       set_current_p2mschap();
		       if (!tmp_p2mschap->username)
			 tmp_p2mschap->username = yyvsp[0].str;
		       else
			 free(yyvsp[0].str);
                     }
break;
case 246:
#line 1973 "config_grammar.y"
{
                       parameter_debug("mschap username: \"%s\"\n", yyvsp[0].str);
		       set_current_p2mschap();
		       if (!tmp_p2mschap->username)
			 tmp_p2mschap->username = yyvsp[0].str;
		       else
			 free(yyvsp[0].str);
                     }
break;
case 247:
#line 1981 "config_grammar.y"
{
                       parameter_debug("mschap username: \"%s\"\n", yyvsp[0].str);
		       set_current_p2mschap();
		       if (!tmp_p2mschap->username)
			 tmp_p2mschap->username = yyvsp[0].str;
		       else
			 free(yyvsp[0].str);
                     }
break;
case 248:
#line 1989 "config_grammar.y"
{
		       parameter_debug("mschap password: \"%s\"\n", yyvsp[0].str);
		       set_current_p2mschap();
		       if (!tmp_p2mschap->password)
			 tmp_p2mschap->password = yyvsp[0].str;
		       else
			 free(yyvsp[0].str);
		     }
break;
case 249:
#line 1997 "config_grammar.y"
{
		       parameter_debug("mschap password: \"%s\"\n", yyvsp[0].str);
		       set_current_p2mschap();
		       if (!tmp_p2mschap->password)
			 tmp_p2mschap->password = yyvsp[0].str;
		       else
			 free(yyvsp[0].str);
		     }
break;
case 250:
#line 2005 "config_grammar.y"
{
		       parameter_debug("mschap password: \"%s\"\n", yyvsp[0].str);
		       set_current_p2mschap();
		       if (!tmp_p2mschap->password)
			 tmp_p2mschap->password = yyvsp[0].str;
		       else
			 free(yyvsp[0].str);
		     }
break;
case 251:
#line 2016 "config_grammar.y"
{
                       set_current_ttls(); 
		       if (!config_ttls_phase2_contains_phase2(tmp_ttls->phase2,
							       TTLS_PHASE2_MSCHAPV2))
			 add_config_ttls_phase2(&(tmp_ttls->phase2), 
						TTLS_PHASE2_MSCHAPV2,
						tmp_p2mschapv2);
		       else
			 delete_config_mschapv2(&tmp_p2mschapv2);
		       tmp_p2mschapv2 = NULL;
                      }
break;
case 254:
#line 2033 "config_grammar.y"
{
                       parameter_debug("mschapv2 username: \"%s\"\n", yyvsp[0].str);
		       set_current_p2mschapv2();
		       if (!tmp_p2mschapv2->username)
			 tmp_p2mschapv2->username = yyvsp[0].str;
		       else
			 free(yyvsp[0].str);
                     }
break;
case 255:
#line 2041 "config_grammar.y"
{
                       parameter_debug("mschapv2 username: \"%s\"\n", yyvsp[0].str);
		       set_current_p2mschapv2();
		       if (!tmp_p2mschapv2->username)
			 tmp_p2mschapv2->username = yyvsp[0].str;
		       else
			 free(yyvsp[0].str);
                     }
break;
case 256:
#line 2049 "config_grammar.y"
{
                       parameter_debug("mschapv2 username: \"%s\"\n", yyvsp[0].str);
		       set_current_p2mschapv2();
		       if (!tmp_p2mschapv2->username)
			 tmp_p2mschapv2->username = yyvsp[0].str;
		       else
			 free(yyvsp[0].str);
                     }
break;
case 257:
#line 2057 "config_grammar.y"
{
		       parameter_debug("mschapv2 password: \"%s\"\n", yyvsp[0].str);
		       set_current_p2mschapv2();
		       if (!tmp_p2mschapv2->password)
			 tmp_p2mschapv2->password = yyvsp[0].str;
		       else
			 free(yyvsp[0].str);
		     }
break;
case 258:
#line 2065 "config_grammar.y"
{
		       parameter_debug("mschapv2 password: \"%s\"\n", yyvsp[0].str);
		       set_current_p2mschapv2();
		       if (!tmp_p2mschapv2->password)
			 tmp_p2mschapv2->password = yyvsp[0].str;
		       else
			 free(yyvsp[0].str);
		     }
break;
case 259:
#line 2073 "config_grammar.y"
{
		       parameter_debug("mschapv2 password: \"%s\"\n", yyvsp[0].str);
		       set_current_p2mschapv2();
		       if (!tmp_p2mschapv2->password)
			 tmp_p2mschapv2->password = yyvsp[0].str;
		       else
			 free(yyvsp[0].str);
		     }
break;
case 260:
#line 2083 "config_grammar.y"
{
		       set_current_ttls();
		       if (!config_ttls_phase2_contains_phase2(tmp_ttls->phase2,
                                                                 TTLS_PHASE2_EAP_MD5))
		         add_config_ttls_phase2(&(tmp_ttls->phase2),
			  	  	        TTLS_PHASE2_EAP_MD5,
					        tmp_md5);
		       else
		         delete_config_eap_md5(&tmp_md5);
		       tmp_p2mschapv2 = NULL;
                     }
break;
case 262:
#line 2097 "config_grammar.y"
{
                        set_current_leap(); /* define an empty leap struct*/
                      }
break;
case 265:
#line 2106 "config_grammar.y"
{
                       parameter_debug("leap username: \"%s\"\n", yyvsp[0].str);
		       set_current_leap();
		       if (!tmp_leap->username)
			 tmp_leap->username = yyvsp[0].str;
		       else
			 free(yyvsp[0].str);
                     }
break;
case 266:
#line 2114 "config_grammar.y"
{
                       parameter_debug("leap username: \"%s\"\n", yyvsp[0].str);
		       set_current_leap();
		       if (!tmp_leap->username)
			 tmp_leap->username = yyvsp[0].str;
		       else
			 free(yyvsp[0].str);
                     }
break;
case 267:
#line 2122 "config_grammar.y"
{
                       parameter_debug("leap username: \"%s\"\n", yyvsp[0].str);
		       set_current_leap();
		       if (!tmp_leap->username)
			 tmp_leap->username = yyvsp[0].str;
		       else
			 free(yyvsp[0].str);
                     }
break;
case 268:
#line 2130 "config_grammar.y"
{
		       parameter_debug("leap password: \"%s\"\n", yyvsp[0].str);
		       set_current_leap();
		       if (!tmp_leap->password)
			 tmp_leap->password = yyvsp[0].str;
		       else
			 free(yyvsp[0].str);
		     }
break;
case 269:
#line 2138 "config_grammar.y"
{
		       parameter_debug("leap password: \"%s\"\n", yyvsp[0].str);
		       set_current_leap();
		       if (!tmp_leap->password)
			 tmp_leap->password = yyvsp[0].str;
		       else
			 free(yyvsp[0].str);
		     }
break;
case 270:
#line 2146 "config_grammar.y"
{
		       parameter_debug("leap password: \"%s\"\n", yyvsp[0].str);
		       set_current_leap();
		       if (!tmp_leap->password)
			 tmp_leap->password = yyvsp[0].str;
		       else
			 free(yyvsp[0].str);
		     }
break;
case 272:
#line 2157 "config_grammar.y"
{
                        set_current_mschapv2(); /* define an empty mschapv2 struct*/
                      }
break;
case 275:
#line 2166 "config_grammar.y"
{
                       parameter_debug("mschapv2 username: \"%s\"\n", yyvsp[0].str);
		       set_current_mschapv2();
		       if (!tmp_mschapv2->username)
			 tmp_mschapv2->username = yyvsp[0].str;
		       else
			 free(yyvsp[0].str);
                     }
break;
case 276:
#line 2174 "config_grammar.y"
{
                       parameter_debug("mschapv2 username: \"%s\"\n", yyvsp[0].str);
		       set_current_mschapv2();
		       if (!tmp_mschapv2->username)
			 tmp_mschapv2->username = yyvsp[0].str;
		       else
			 free(yyvsp[0].str);
                     }
break;
case 277:
#line 2182 "config_grammar.y"
{
		       parameter_debug("mschapv2 username: \"%s\"\n", yyvsp[0].str);
		       set_current_mschapv2();
		       if (!tmp_mschapv2->username)
			 tmp_mschapv2->username = yyvsp[0].str;
		       else
			 free(yyvsp[0].str);
                     }
break;
case 278:
#line 2190 "config_grammar.y"
{
		       parameter_debug("mschapv2 password: \"%s\"\n", yyvsp[0].str);
		       set_current_mschapv2();
		       if (!tmp_mschapv2->password)
			 tmp_mschapv2->password = yyvsp[0].str;
		       else
			 free(yyvsp[0].str);
		     }
break;
case 279:
#line 2198 "config_grammar.y"
{
		       parameter_debug("mschapv2 password: \"%s\"\n", yyvsp[0].str);
		       set_current_mschapv2();
		       if (!tmp_mschapv2->password)
			 tmp_mschapv2->password = yyvsp[0].str;
		       else
			 free(yyvsp[0].str);
		     }
break;
case 280:
#line 2206 "config_grammar.y"
{
		       parameter_debug("mschapv2 password: \"%s\"\n", yyvsp[0].str);
		       set_current_mschapv2();
		       if (!tmp_mschapv2->password)
			 tmp_mschapv2->password = yyvsp[0].str;
		       else
			 free(yyvsp[0].str);
		     }
break;
case 281:
#line 2214 "config_grammar.y"
{
                       parameter_debug("mschapv2 NT password hash: \"%s\"\n", yyvsp[0].str);
                       set_current_mschapv2();
                       if (!tmp_mschapv2->nthash)
                         tmp_mschapv2->nthash = yyvsp[0].str;
                       else
                         free(yyvsp[0].str);
                     }
break;
case 283:
#line 2225 "config_grammar.y"
{
                        set_current_peap(); /* define an empty peap struct*/
                      }
break;
case 286:
#line 2234 "config_grammar.y"
{
                            parameter_debug("ID: \"%s\"\n", yyvsp[0].str);
			    set_current_peap();
			    if (!tmp_peap->identity)
			      tmp_peap->identity = yyvsp[0].str;
			    else
			      free(yyvsp[0].str);
                          }
break;
case 287:
#line 2242 "config_grammar.y"
{
                            parameter_debug("ID: \"%s\"\n", yyvsp[0].str);
			    set_current_peap();
			    if (!tmp_peap->identity)
			      tmp_peap->identity = yyvsp[0].str;
			    else
			      free(yyvsp[0].str);
                          }
break;
case 288:
#line 2250 "config_grammar.y"
{
                            parameter_debug("ID: \"%s\"\n", yyvsp[0].str);
			    set_current_peap();
			    if (!tmp_peap->identity)
			      tmp_peap->identity = yyvsp[0].str;
			    else
			      free(yyvsp[0].str);
                          }
break;
case 289:
#line 2258 "config_grammar.y"
{
                        parameter_debug("peap user cert: \"%s\"\n", yyvsp[0].str);
			set_current_peap();
			if (!tmp_peap->user_cert)
			  tmp_peap->user_cert = yyvsp[0].str;
			else
			  free(yyvsp[0].str);
                      }
break;
case 290:
#line 2266 "config_grammar.y"
{
                        parameter_debug("peap user cert: \"%s\"\n", yyvsp[0].str);
			set_current_peap();
			if (!tmp_peap->user_cert)
			  tmp_peap->user_cert = yyvsp[0].str;
			else
			  free(yyvsp[0].str);
                      }
break;
case 291:
#line 2274 "config_grammar.y"
{
	 	        parameter_debug("peap user key: \"%s\"\n", yyvsp[0].str);
			set_current_peap();
			if (!tmp_peap->user_key)
			  tmp_peap->user_key = yyvsp[0].str;
			else 
			  free(yyvsp[0].str);
        	      }
break;
case 292:
#line 2282 "config_grammar.y"
{
	 	        parameter_debug("peap user key: \"%s\"\n", yyvsp[0].str);
			set_current_peap();
			if (!tmp_peap->user_key)
			  tmp_peap->user_key = yyvsp[0].str;
			else 
			  free(yyvsp[0].str);
        	      }
break;
case 293:
#line 2290 "config_grammar.y"
{
	 	        parameter_debug("peap user pass: \"%s\"\n", yyvsp[0].str);
			set_current_peap();
			if (!tmp_peap->user_key_pass)
			  tmp_peap->user_key_pass = yyvsp[0].str;
			else
			  free(yyvsp[0].str);
        	      }
break;
case 294:
#line 2298 "config_grammar.y"
{
	 	        parameter_debug("peap user pass: \"%s\"\n", yyvsp[0].str);
			set_current_peap();
			if (!tmp_peap->user_key_pass)
			  tmp_peap->user_key_pass = yyvsp[0].str;
			else
			  free(yyvsp[0].str);
        	      }
break;
case 295:
#line 2306 "config_grammar.y"
{
	 	        parameter_debug("peap user pass: \"%s\"\n", yyvsp[0].str);
			set_current_peap();
			if (!tmp_peap->user_key_pass)
			  tmp_peap->user_key_pass = yyvsp[0].str;
			else
			  free(yyvsp[0].str);
        	      }
break;
case 296:
#line 2314 "config_grammar.y"
{
	 	        parameter_debug("peap root_cert: \"%s\"\n", yyvsp[0].str);
			set_current_peap();
			if (!tmp_peap->root_cert)
			  tmp_peap->root_cert = yyvsp[0].str;
			else
			  free(yyvsp[0].str);
        	      }
break;
case 297:
#line 2322 "config_grammar.y"
{
	 	        parameter_debug("peap root_cert: \"%s\"\n", yyvsp[0].str);
			set_current_peap();
			if (!tmp_peap->root_cert)
			  tmp_peap->root_cert = yyvsp[0].str;
			else
			  free(yyvsp[0].str);
        	      }
break;
case 298:
#line 2330 "config_grammar.y"
{
	 	        parameter_debug("peap root_dir: \"%s\"\n", yyvsp[0].str);
			set_current_peap();
			if (!tmp_peap->root_dir)
			  tmp_peap->root_dir = yyvsp[0].str;
			else 
			  free(yyvsp[0].str);
        	      }
break;
case 299:
#line 2338 "config_grammar.y"
{
	 	        parameter_debug("peap root_dir: \"%s\"\n", yyvsp[0].str);
			set_current_peap();
			if (!tmp_peap->root_dir)
			  tmp_peap->root_dir = yyvsp[0].str;
			else 
			  free(yyvsp[0].str);
        	      }
break;
case 300:
#line 2346 "config_grammar.y"
{
	 	        parameter_debug("peap crl_dir: \"%s\"\n", yyvsp[0].str);
			set_current_peap();
			if (!tmp_peap->crl_dir)
			  tmp_peap->crl_dir = yyvsp[0].str;
			else 
			  free(yyvsp[0].str);
        	      }
break;
case 301:
#line 2354 "config_grammar.y"
{
	 	        parameter_debug("peap crl_dir: \"%s\"\n", yyvsp[0].str);
			set_current_peap();
			if (!tmp_peap->crl_dir)
			  tmp_peap->crl_dir = yyvsp[0].str;
			else 
			  free(yyvsp[0].str);
        	      }
break;
case 302:
#line 2362 "config_grammar.y"
{
		        parameter_debug("Session Resumption = YES\n");
		        set_current_peap();
		        if (tmp_peap->session_resume == RES_UNSET)
			  tmp_peap->session_resume = RES_YES;
		      }
break;
case 303:
#line 2368 "config_grammar.y"
{
			parameter_debug("Session Resumption = NO\n");
			set_current_peap();
			if (tmp_peap->session_resume == RES_UNSET)
			  tmp_peap->session_resume = RES_NO;
		      }
break;
case 304:
#line 2374 "config_grammar.y"
{
		      set_current_peap();
		      tmp_peap->session_resume = RES_NO;
		      printf("Invalid setting for PEAP session resumption = \"%s\"!  Defaulting to NO! (Line : %d)\n", yyvsp[0].str, config_linenum);
		    }
break;
case 305:
#line 2379 "config_grammar.y"
{
		      parameter_debug("Proper PEAPv1 Keying = YES\n");
		      set_current_peap();
		      if (tmp_peap->proper_peapv1 == 0)
			tmp_peap->proper_peapv1 = 1;
		    }
break;
case 306:
#line 2385 "config_grammar.y"
{
		      parameter_debug("Proper PEAPv1 Keying = NO\n");
		      set_current_peap();
		      if (tmp_peap->proper_peapv1 == 1)
			tmp_peap->proper_peapv1 = 0;
		    }
break;
case 307:
#line 2391 "config_grammar.y"
{
		      parameter_debug("Unknown 'Proper PEAPv1 Keying' setting!\n");
		      printf("Unknown value for 'proper_peap_v1_keying'!\n");
		    }
break;
case 308:
#line 2395 "config_grammar.y"
{
                      parameter_debug("inner id : %s\n", yyvsp[0].str);
                      set_current_peap();
                      if (!tmp_peap->identity)
			tmp_peap->identity = yyvsp[0].str;
                    }
break;
case 309:
#line 2401 "config_grammar.y"
{
		      parameter_debug("inner id : %s\n", yyvsp[0].str);
		      set_current_peap();
		      if (!tmp_peap->identity)
			tmp_peap->identity = yyvsp[0].str;
		    }
break;
case 310:
#line 2407 "config_grammar.y"
{
 		        parameter_debug("peap chunk: %d\n", yyvsp[0].num);
			set_current_peap();
			if (tmp_peap->chunk_size == 0)
			  tmp_peap->chunk_size = yyvsp[0].num;
  		      }
break;
case 311:
#line 2413 "config_grammar.y"
{
		        parameter_debug("peap CN check : \"%s\"\n", yyvsp[0].str);
                        set_current_peap();
                        if (!tmp_peap->cncheck)
                          tmp_peap->cncheck = yyvsp[0].str;
                        else
                          free(yyvsp[0].str);
		      }
break;
case 312:
#line 2421 "config_grammar.y"
{
  		        parameter_debug("match CN exactly : \"yes\"\n");
		        set_current_peap();
		        tmp_peap->cnexact = 1;
		    }
break;
case 313:
#line 2426 "config_grammar.y"
{
  		        parameter_debug("match CN exactly : \"no\"\n");
		        set_current_peap();
		        tmp_peap->cnexact = 0;
       		    }
break;
case 314:
#line 2431 "config_grammar.y"
{
	 	        parameter_debug("peap rand: \"%s\"\n", yyvsp[0].str);
			set_current_peap();
			if (!tmp_peap->random_file)
			  tmp_peap->random_file = yyvsp[0].str;
			else 
			  free(yyvsp[0].str);
        	      }
break;
case 315:
#line 2439 "config_grammar.y"
{
	 	        parameter_debug("peap rand: \"%s\"\n", yyvsp[0].str);
			set_current_peap();
			if (!tmp_peap->random_file)
			  tmp_peap->random_file = yyvsp[0].str;
			else 
			  free(yyvsp[0].str);
        	      }
break;
case 316:
#line 2447 "config_grammar.y"
{
		       parameter_debug("peap ias quirk: YES\n");
		       set_current_peap();
		       tmp_peap->ias_quirk=1;
		     }
break;
case 317:
#line 2452 "config_grammar.y"
{
		       parameter_debug("peap ias quirk: NO\n");
		       set_current_peap();
		       tmp_peap->ias_quirk=0;
		     }
break;
case 318:
#line 2457 "config_grammar.y"
{
		       parameter_debug("peap ias quirk: %s\n", yyvsp[0].str);
		       parameter_debug("Defaulting to NO!\n");
		       set_current_peap();
		       tmp_peap->ias_quirk=0;
		     }
break;
case 319:
#line 2463 "config_grammar.y"
{}
break;
case 320:
#line 2464 "config_grammar.y"
{}
break;
case 321:
#line 2467 "config_grammar.y"
{
                           parameter_debug("PEAP Allow Types: ALL\n");
			   set_current_peap();
			   SET_FLAG(tmp_peap->flags, CONFIG_PEAP_ALLOW_ALL);
                       }
break;
case 325:
#line 2479 "config_grammar.y"
{
                          parameter_debug("PEAP Allow Type: MSCHAPV2\n");
	  	  	  set_current_peap();
			  SET_FLAG(tmp_peap->flags, CONFIG_PEAP_ALLOW_MSCV2);
                        }
break;
case 326:
#line 2484 "config_grammar.y"
{
                          parameter_debug("PEAP Allow Type: MD5\n");
	  	  	  set_current_peap();
			  SET_FLAG(tmp_peap->flags, CONFIG_PEAP_ALLOW_MD5);
                        }
break;
case 327:
#line 2489 "config_grammar.y"
{
                          parameter_debug("PEAP Allow Type: SIM\n");
	  	  	  set_current_peap();
			  SET_FLAG(tmp_peap->flags, CONFIG_PEAP_ALLOW_SIM);
                        }
break;
case 328:
#line 2494 "config_grammar.y"
{
                          parameter_debug("PEAP Allow Type: OTP\n");
	  	  	  set_current_peap();
			  SET_FLAG(tmp_peap->flags, CONFIG_PEAP_ALLOW_OTP);
                        }
break;
case 329:
#line 2499 "config_grammar.y"
{
                          parameter_debug("PEAP Allow Type: GTC\n");
	  	  	  set_current_peap();
			  SET_FLAG(tmp_peap->flags, CONFIG_PEAP_ALLOW_GTC);
                        }
break;
case 330:
#line 2507 "config_grammar.y"
{
                             set_current_peap(); 
	   	             if (!config_eap_method_contains_method(tmp_peap->phase2,
								    EAP_TYPE_MSCHAPV2))
			       {
			       add_config_eap_method(&(tmp_peap->phase2),
						     EAP_TYPE_MSCHAPV2,
						     tmp_mschapv2);

			       /* If we don't have an identity, then copy this*/
			       /* one.*/
			       if (!tmp_peap->identity)
				 {
				   tmp_peap->identity = strdup(tmp_mschapv2->username);
				 }
			       }
			     else
			       delete_config_eap_mschapv2(&tmp_mschapv2);
			     tmp_mschapv2 = NULL;
                            }
break;
case 331:
#line 2527 "config_grammar.y"
{
                             set_current_peap(); 
	   	             if (!config_eap_method_contains_method(tmp_peap->phase2,
								    EAP_TYPE_MD5))
			       {
			       add_config_eap_method(&(tmp_peap->phase2),
						     EAP_TYPE_MD5,
						     tmp_md5);

			       /* If we don't have an identity, then copy this*/
			       /* one.*/
			       if (!tmp_peap->identity)
				 {
				   tmp_peap->identity = strdup(tmp_md5->username);
				 }
			       }
			     else
			       delete_config_eap_md5(&tmp_md5);
			     tmp_md5 = NULL;
                            }
break;
case 332:
#line 2547 "config_grammar.y"
{
                             set_current_peap(); 
	   	             if (!config_eap_method_contains_method(tmp_peap->phase2,
								    EAP_TYPE_SIM))
			       {
			       add_config_eap_method(&(tmp_peap->phase2),
						     EAP_TYPE_SIM,
						     tmp_sim);
			       
			       /* If we don't have an identity, then copy this*/
			       /* one.*/
			       if (!tmp_peap->identity)
				 {
				   tmp_peap->identity = strdup(tmp_sim->username);
				 }
			       }
			     else
			       delete_config_eap_sim(&tmp_sim);
			     tmp_sim = NULL;
                            }
break;
case 334:
#line 2570 "config_grammar.y"
{
                        set_current_sim(); /* define an empty sim struct*/
                      }
break;
case 337:
#line 2579 "config_grammar.y"
{
                       parameter_debug("sim username: \"%s\"\n", yyvsp[0].str);
		       set_current_sim();
		       if (!tmp_sim->username)
			 tmp_sim->username = yyvsp[0].str;
		       else
			 free(yyvsp[0].str);
                     }
break;
case 338:
#line 2587 "config_grammar.y"
{
                       parameter_debug("sim username: \"%s\"\n", yyvsp[0].str);
		       set_current_sim();
		       if (!tmp_sim->username)
			 tmp_sim->username = yyvsp[0].str;
		       else
			 free(yyvsp[0].str);
                     }
break;
case 339:
#line 2595 "config_grammar.y"
{
                       parameter_debug("sim username: \"%s\"\n", yyvsp[0].str);
		       set_current_sim();
		       if (!tmp_sim->username)
			 tmp_sim->username = yyvsp[0].str;
		       else
			 free(yyvsp[0].str);
                     }
break;
case 340:
#line 2603 "config_grammar.y"
{
		       parameter_debug("sim password: \"%s\"\n", yyvsp[0].str);
		       set_current_sim();
		       if (!tmp_sim->password)
			 tmp_sim->password = yyvsp[0].str;
		       else
			 free(yyvsp[0].str);
		     }
break;
case 341:
#line 2611 "config_grammar.y"
{
		       parameter_debug("sim password: \"%s\"\n", yyvsp[0].str);
		       set_current_sim();
		       if (!tmp_sim->password)
			 tmp_sim->password = yyvsp[0].str;
		       else
			 free(yyvsp[0].str);
		     }
break;
case 342:
#line 2619 "config_grammar.y"
{
		       parameter_debug("sim password: \"%s\"\n", yyvsp[0].str);
		       set_current_sim();
		       if (!tmp_sim->password)
			 tmp_sim->password = yyvsp[0].str;
		       else
			 free(yyvsp[0].str);
		     }
break;
case 343:
#line 2627 "config_grammar.y"
{
  		       parameter_debug("sim auto_realm: \"yes\"\n");
		       set_current_sim();
		       tmp_sim->auto_realm = 1;
		   }
break;
case 344:
#line 2632 "config_grammar.y"
{
  		       parameter_debug("sim auto_realm: \"no\"\n");
		       set_current_sim();
		       tmp_sim->auto_realm = 0;
		   }
break;
case 345:
#line 2637 "config_grammar.y"
{
		       parameter_debug("sim auto_realm: \"%s\"\n", yyvsp[0].str);
		       parameter_debug("Defaulting to NO!\n");
		       set_current_sim();
		       tmp_sim->auto_realm = 0;
		   }
break;
case 347:
#line 2645 "config_grammar.y"
{
                        set_current_aka(); /* define an empty aka struct*/
                      }
break;
case 350:
#line 2654 "config_grammar.y"
{
                       parameter_debug("aka username: \"%s\"\n", yyvsp[0].str);
		       set_current_aka();
		       if (!tmp_aka->username)
			 tmp_aka->username = yyvsp[0].str;
		       else
			 free(yyvsp[0].str);
                     }
break;
case 351:
#line 2662 "config_grammar.y"
{
                       parameter_debug("aka username: \"%s\"\n", yyvsp[0].str);
		       set_current_aka();
		       if (!tmp_aka->username)
			 tmp_aka->username = yyvsp[0].str;
		       else
			 free(yyvsp[0].str);
                     }
break;
case 352:
#line 2670 "config_grammar.y"
{
                       parameter_debug("aka username: \"%s\"\n", yyvsp[0].str);
		       set_current_aka();
		       if (!tmp_aka->username)
			 tmp_aka->username = yyvsp[0].str;
		       else
			 free(yyvsp[0].str);
                     }
break;
case 353:
#line 2678 "config_grammar.y"
{
		       parameter_debug("aka password: \"%s\"\n", yyvsp[0].str);
		       set_current_aka();
		       if (!tmp_aka->password)
			 tmp_aka->password = yyvsp[0].str;
		       else
			 free(yyvsp[0].str);
		     }
break;
case 354:
#line 2686 "config_grammar.y"
{
		       parameter_debug("aka password: \"%s\"\n", yyvsp[0].str);
		       set_current_aka();
		       if (!tmp_aka->password)
			 tmp_aka->password = yyvsp[0].str;
		       else
			 free(yyvsp[0].str);
		     }
break;
case 355:
#line 2694 "config_grammar.y"
{
		       parameter_debug("aka password: \"%s\"\n", yyvsp[0].str);
		       set_current_aka();
		       if (!tmp_aka->password)
			 tmp_aka->password = yyvsp[0].str;
		       else
			 free(yyvsp[0].str);
		     }
break;
case 356:
#line 2702 "config_grammar.y"
{
  		       parameter_debug("aka auto_realm: \"yes\"\n");
		       set_current_aka();
		       tmp_aka->auto_realm = 1;
		   }
break;
case 357:
#line 2707 "config_grammar.y"
{
  		       parameter_debug("aka auto_realm: \"no\"\n");
		       set_current_aka();
		       tmp_aka->auto_realm = 0;
		   }
break;
case 358:
#line 2712 "config_grammar.y"
{
		       parameter_debug("aka auto_realm: \"%s\"\n", yyvsp[0].str);
		       set_current_aka();
		       tmp_aka->auto_realm = 0;
		   }
break;
case 360:
#line 2719 "config_grammar.y"
{
                       set_current_wpa_psk(); /* define an empty wpa psk struct*/
                   }
break;
case 363:
#line 2728 "config_grammar.y"
{
                       parameter_debug("ascii key : \"%s\"\n", yyvsp[0].str);
                       set_current_wpa_psk();
		       if (!tmp_wpa_psk->key)
			 tmp_wpa_psk->key = yyvsp[0].str;
		       else
			 free(yyvsp[0].str);
                   }
break;
case 364:
#line 2736 "config_grammar.y"
{
                       parameter_debug("ascii key : \"%s\"\n", yyvsp[0].str);
                       set_current_wpa_psk();
		       if (!tmp_wpa_psk->key)
			 tmp_wpa_psk->key = yyvsp[0].str;
		       else
			 free(yyvsp[0].str);
                   }
break;
case 365:
#line 2744 "config_grammar.y"
{
                       parameter_debug("hex key : \"%s\"\n", yyvsp[0].str);
                       set_current_wpa_psk();
                       if (!tmp_wpa_psk->hex_key)
                         tmp_wpa_psk->hex_key = yyvsp[0].str;
                       else
                         free(yyvsp[0].str);
                   }
break;
#line 4468 "config_grammar.c"
    }
    yyssp -= yym;
    yystate = *yyssp;
    yyvsp -= yym;
    yym = yylhs[yyn];
    if (yystate == 0 && yym == 0)
    {
#if YYDEBUG
        if (yydebug)
            printf("%sdebug: after reduction, shifting from state 0 to\
 state %d\n", YYPREFIX, YYFINAL);
#endif
        yystate = YYFINAL;
        *++yyssp = YYFINAL;
        *++yyvsp = yyval;
        if (yychar < 0)
        {
            if ((yychar = yylex()) < 0) yychar = 0;
#if YYDEBUG
            if (yydebug)
            {
                yys = 0;
                if (yychar <= YYMAXTOKEN) yys = yyname[yychar];
                if (!yys) yys = "illegal-symbol";
                printf("%sdebug: state %d, reading %d (%s)\n",
                        YYPREFIX, YYFINAL, yychar, yys);
            }
#endif
        }
        if (yychar == 0) goto yyaccept;
        goto yyloop;
    }
    if ((yyn = yygindex[yym]) && (yyn += yystate) >= 0 &&
            yyn <= YYTABLESIZE && yycheck[yyn] == yystate)
        yystate = yytable[yyn];
    else
        yystate = yydgoto[yym];
#if YYDEBUG
    if (yydebug)
        printf("%sdebug: after reduction, shifting from state %d \
to state %d\n", YYPREFIX, *yyssp, yystate);
#endif
    if (yyssp >= yyss + yystacksize - 1)
    {
        goto yyoverflow;
    }
    *++yyssp = yystate;
    *++yyvsp = yyval;
    goto yyloop;
yyoverflow:
    yyerror("yacc stack overflow");
yyabort:
    return (1);
yyaccept:
    return (0);
}
